#!/usr/bin/wishx
source ~/MP3Tool/func2.tcl
source ~/MP3Tool/server.tcl
source ~/MP3Tool/configure.tcl
source ~/MP3Tool/files.tcl

if {[winfo exists .mp3]} {destroy .mp3}
if {[winfo exists .send]} {destroy .send}
if {[winfo exists .recycle]} {destroy .recycle}
if {[winfo exists .help]} {destroy .help}
if {[winfo exists .server]} {destroy .server}
if {[winfo exists .configure]} {destroy .configure}
if {[winfo exists .queuser]} {destroy .queuser}

global mp3dirs sends sendlist
global serverdirs total_lists
global total_files grand_total grand_file grand_date recentcount
global scrlk recent quebutton questatus queuser
global quefile questart totfin mp3tool quepercent
global connections slotname slotsend
global slotsavail slottime slotque slotqavail slotcps slotfiles
global slotexp findtimer

set mp3tool(debug) 0
set mp3tool(offleft) 0
set mp3tool(offright) 0

set total_lists 0
set total_files 0
set mp3tool(serving) 0
set recentcount 0
set mp3tool(quecount) 0
set mp3tool(chlst) 1
set mp3tool(lastoffer) 0
set sendlist(0) "nothing"
set mp3tool(client) "epic ircII"
set mp3tool(totalcps) 0
set mp3tool(totalslots) 0
set mp3tool(chan) "--SETMEUP--"
set connections 0

SetVars
set mp3tool(advertisement) "http://www.daytona.com/mp3tool/"
set mp3tool(color_advertisement) "\0034http://www.daytona.com/mp3tool/"

label .info -text "MP3Tool for $mp3tool(client)"
image create photo logo -file $mp3tool(dir)/images/tool.gif
label .logo -image logo
button .begin -text "Load MP3Tool" -command GetWindowSetup
label .status -text "[Trans finds] 0 -- [Trans lists] 0 -- [Trans sent] 0"
text .text -height 25 -width 72
pack .logo
pack .info
pack .status
if {$mp3tool(debug)} {pack .text}
bind . <Control-d> {ToggleDebug}
wm iconbitmap . @$mp3tool(dir)/images/star.xbm
GetWindowSetup
SetGrandTotal

global sock
set sock -1

socket -server NewConnect -myaddr 127.0.0.1 7007

proc NewConnect {sck address remport} {
	global sock mp3tool connections

	if {$address != "127.0.0.1"} {
		close $sck
		return
	}
	if {$connections} {
		if {$mp3tool(debug)} {
			.text insert end "Closing Old Socket For New Connection.\n"
			.text see end
		}
		fileevent $sock readable {}
		close $sock
	}
	set connections 1
	set sock $sck
	fileevent $sock readable InPut
	if {$mp3tool(debug)} {
		.text insert end "Connect from $address $remport\n"
		.text see end
	}
}

proc OffRight { } {
	global mp3tool
	.mp3.scrlx.act.r configure -image offright
	set mp3tool(offright) 0
}

proc OffLeft { } {
	global mp3tool
	.mp3.scrlx.act.l configure -image offleft
	set mp3tool(offleft) 0
}

proc ToggleDebug { } {
        global mp3tool
        if {$mp3tool(debug)} {
                pack forget .text
                set mp3tool(debug) 0
        } {
                pack .text
                set mp3tool(debug) 1
        }
}

proc InPut {} {
	global sock mp3tool 

	update idletasks
	set input ""
	catch {gets $sock input} error
	if {[string length $error] > 4} {
		ErrorNotify "InPut" $error
	}
	if {$input == "" || [eof $sock] == 1} {
		if {$mp3tool(debug)} {
			.text insert end "Client Disconnected!\n"
			.text see end
		}
		fileevent $sock readable {}
		return
	}
	if {$mp3tool(debug)} {
		.text insert end "<- $input\n"
		.text see end
	}
	.mp3.scrlx.act.l configure -image onleft
	PrInPut $input
	if {!$mp3tool(offleft)} {
		set mp3tool(offleft) 1
		after 200 OffLeft
	}
}

proc PrInPut {input} {
	global sock mp3tool scrlk quefile sends
	global total_lists totfin total_files queuser questatus
	global slotexp slotsend slotsavail slottime slotque
	global slotqavail slotcps slotfiles slotname

	set op [string range $input 0 [expr [string first " " $input] -1]]
	switch -exact $op {
		"OFFER" {
			set fstr [string range $input [expr [string first " " $input] +1] end]
			set user [string range $fstr 0 [expr [string first " " $fstr] -1]]
			set file [string trim [string range $fstr [expr [string first " " $fstr] +1] [expr [string first ".mp3" [string tolower $fstr]] +3]]]
			if ![winfo exists .mp3] {
                		GetWindowSetup
        		}
			set isfile [HasFile $file]
			if {$isfile == "--"} {
				.mp3.l.list insert end "\[[clock format [clock seconds] -format "%T"]\] $user $file"
				incr mp3tool(total)
			} else {
				.mp3.pl.entry delete 0 end
				.mp3.pl.entry insert end $isfile
			}
			while {$mp3tool(total) > $mp3tool(maxmp3s)} {
				.mp3.l.list delete 0
				incr mp3tool(total) -1
			}
			if { !$scrlk } {
				.mp3.l.list see end
			}
		}
		"NICK" {
			if {[string range $input [expr [string first " " $input] +1] end] != $mp3tool(nick)} {
				set mp3tool(nick) [string range $input [expr [string first " " $input] +1] end]
				CreateListQuestion 1
			}
		}
		"USERNICK" {
			set work [string range $input [expr [string first " " $input] +1] end]
			set who [string range $work 0 [expr [string first " " $work] -1]]
			set newwho [string range $work [expr [string first " " $work] +1] end]
			for {set c 0} {$c < $mp3tool(quecount)} {incr c} {
				if {$queuser($c) == $who} {
					set queuser($c) $newwho
				}
			}
		}
		"LIST" {
			if {$mp3tool(serving)} {
				set who [string range $input [expr [string first " " $input] +1] end]
				if $sends(LIST) {
					.mp3.scrlx.act.r configure -image onright
					SendFILE $who $mp3tool(filelist)
					incr total_lists
					.status configure -text "[Trans finds] $totfin -- [Trans lists] $total_lists -- [Trans sent] $total_files"
					if {!$mp3tool(offright)} {
						set mp3tool(offright) 1
						after 200 OffRight
					}
				}
			}
		}
		"MP3TOOL" {
			if {$mp3tool(distribute)} {
				set who [string range $input [expr [string first " " $input] +1] end]
				.mp3.scrlx.act.r configure -image onright
				SendFILE $who "/home/cruise/MP3Tool-Dist/MP3Tool.zip"
				if {[string length $error] > 4} {
					ErrorNotify "PrInPut" $error
				}
				if {!$mp3tool(offright)} {
					set mp3tool(offright) 1
					after 200 OffRight
				}
			}
		}
		"FILE" {
			if {$mp3tool(serving)} {
				set work [string range $input [expr [string first " " $input] +1] end]
				set who [string range $work 0 [expr [string first " " $work] -1]]
				set work [string range $work [expr [string first " " $work] +1] end]
				set file [string range $work [expr [string first " " $work] +1] end]
                                # SPR Jukebox's Grabber
                                if {[string first "<---" $file] != -1} {
                                        set file [string range $file 0 [expr [string first "<---" $file] -1]]
                                }
				set file [StripColor $file]
				QueRequest [string trim $file] $who
			}
		}
		"FIND" {
			if {$mp3tool(serving)} {
				set work [string range $input [expr [string first " " $input] +1] end]
				set who [string range $work 0 [expr [string first " " $work] -1]]
				set what [string range $work [expr [string first " " $work] +1] end]
				Find_File $who $what
			}
		}
		"CTCPFIND" {
			if {$mp3tool(serving)} {
				set work [string range $input [expr [string first " " $input] +1] end]
				set who [string range $work 0 [expr [string first " " $work] -1]]
				set what [string range $work [expr [string first " " $work] +1] end]
				CTCP_Find_File $who $what
			}
		}
		"QUE" {
			if {$mp3tool(serving)} {
				set who [string range $input [expr [string first " " $input] +1] end]
				que_report $who
			}
		}
		"REMOVE" {
			if {$mp3tool(serving)} {
				set who [string range $input [expr [string first " " $input] +1] end]
				que_remove $who
			}
		}
		"UNF" {
			.status configure -text "[Trans finds] $totfin -- [Trans lists] $total_lists -- [Trans sent] $total_files"
			set unf_parts [string range $input [expr [string first " " $input] +1] end]
			set unf_user [string range $unf_parts 0 [expr [string first " " $unf_parts] -1]]
			set unf_file [string range $unf_parts [expr [string first " " $unf_parts] +1]  end]
			set c [MatchUnf $unf_user $unf_file]
			if {$c >= 0} {
				if {$mp3tool(debug)} {
					.text insert end "Failed Transfer! $unf_user $unf_file $c\n"
					.text see end
				}
				incr mp3tool(usedslots) -1
				set inusebyother 0
				catch {
				for {set d 0} {$d < $mp3tool(quecount)} {incr d} {
					if {$quefile($d) == $quefile($c) && $d != $c} {
						set inusebyother 1
					}
				}} error
				if {[string length $error] > 4} {
					ErrorNotify "PrInPut" $error
				}
				if {[file exists "$mp3tool(dir)/tmp/$quefile($c)"] && !$inusebyother} {
					if {"$mp3tool(dir)/tmp/$quefile($c)" != "$mp3tool(dir)/tmp/"} {
						catch {file delete "$mp3tool(dir)/tmp/$quefile($c)"} error
						if {[string length $error] > 4} {
							ErrorNotify "PrInPut" $error
						}
					}
				}
				if {$questatus($c) != "Done"} {
					set questatus($c) "Done"
					set questart($c) [clock seconds]
					if [winfo exists .queuser] {
						.queuser.status.v configure  -text [Trans done]
						.queuser.time.v configure -text [clock format $questart($c) -format "%T"]
					}
				}
				set n [nick_fix $queuser($c)]
				set f [nick_fix $quefile($c)]
				if {$sends(COLOR)} {
					after 5000 "SendMSG $n  \"\0031,1\00304$f \0033[Trans has_ended_with_an] \0037[Trans error] \0033[Trans status_you_are_welcomed_to_re-request_it]. $mp3tool(color_advertisement)\""
				} {
					after 5000 "SendMSG $n \"[Trans the_transfer_for] $f [Trans has_ended_with_an] [Trans error] [Trans status_you_are_welcomed_to_re-request_it]. $mp3tool(advertisement)\""
				}
				ShuffleQue $c
			} else {
				if {$mp3tool(debug)} {
					.text insert end "UNKNOWN USER IGNORED (Failed Transfer [MatchUnf $unf_user $unf_file] $unf_user $unf_file)\n"
					.text see end
				}
			}
		}
		"SLOTS" {
			set work [string range $input [expr [string first " " $input] +1] end]
			set name [string range $work 0 [expr [string first " " $work] -1]]
			set work [string range $work [expr [string first " " $work] +1] end]
			set send [string range $work 0 [expr [string first " " $work] -1]]
			set work [string range $work [expr [string first " " $work] +1] end]
			set savail [string range $work 0 [expr [string first " " $work] -1]]
			set work [string range $work [expr [string first " " $work] +1] end]
			set time [string range $work 0 [expr [string first " " $work] -1]]
			set work [string range $work [expr [string first " " $work] +1] end]
			set qavail [string range $work 0 [expr [string first " " $work] -1]]
			set work [string range $work [expr [string first " " $work] +1] end]
			set que [string range $work 0 [expr [string first " " $work] -1]]
			set work [string range $work [expr [string first " " $work] +1] end]
			set cps [string range $work 0 [expr [string first " " $work] -1]]
			set files [string range $work [expr [string first " " $work] +1] end]
			if {[string first " " $files] != -1} {
				set files [string range $files 0 [expr [string first " " $files] -1]]
			}
			if {[string first "(" $files] != -1} {
				set files [string range $files 0 [expr [string first "(" $files] -1]]
			}
			set seconds [clock seconds]
			if {$mp3tool(totalslots)} {
				set flag 0
				for {set c 1} {$c <= $mp3tool(totalslots) && !$flag} {incr c} {
					if {$slotname($c) == $name} {
						## Use this one!
						set slotname($c) $name
						set slotsend($c) $send
						set slotsavail($c) $savail
						set slottime($c) $time
						set slotqavail($c) $qavail
						set slotque($c) $que
						set slotcps($c) $cps
						set slotfiles($c) $files
						set slotexp($c) [expr $seconds + 900]
						if {[winfo exists .slots]} {
							if {[winfo exists .slots.f.text.$c]} {
								.slots.f.text.$c.send$c configure -text $send
								.slots.f.text.$c.savail$c configure -text $savail
								.slots.f.text.$c.time$c configure -text $time
								.slots.f.text.$c.qye$c configure -text $que
								.slots.f.text.$c.qavail$c configure -text $qavail
								.slots.f.text.$c.cps$c configure -text $cps
								.slots.f.text.$c.files$c configure -text $files
								update
							}
						}
						set flag 1
					}
				}
				if {!$flag} {
					for {set c 1} {$c <= $mp3tool(totalslots) && !$flag} {incr c} {
						if {$slotexp($c) <= $seconds} {
							## Use this one!
							set slotname($c) $name
							set slotsend($c) $send
							set slotsavail($c) $savail
							set slottime($c) $time
							set slotqavail($c) $qavail
							set slotque($c) $que
							set slotcps($c) $cps
							set slotfiles($c) $files
							set slotexp($c) [expr $seconds + 900]
							if {[winfo exists .slots]} {
								if {[winfo exists .slots.f.text.$c]} {
									.slots.f.text.$c.but$c configure -text $name -command "InfoButton $c"
									.slots.f.text.$c.send$c configure -text $send
									.slots.f.text.$c.savail$c configure -text $savail
									.slots.f.text.$c.time$c configure -text $time
									.slots.f.text.$c.qye$c configure -text $que
									.slots.f.text.$c.qavail$c configure -text $qavail
									.slots.f.text.$c.cps$c configure -text $cps
									.slots.f.text.$c.files$c configure -text $files
									update
								} {
                        						frame .slots.f.text.$c
									button .slots.f.text.$c.but$c -text $slotname($c) -command "InfoButton $c" -width 12  
									label .slots.f.text.$c.send$c -text $slotsend($c) -width 10 -bg "light blue" -relief sunken -borderwidth 2
                        						label .slots.f.text.$c.savail$c -text $slotsavail($c) -width 10 -bg "light blue" -relief sunken -borderwidth 2
                        						label .slots.f.text.$c.time$c -text $slottime($c) -width 10 -bg "light blue" -relief sunken -borderwidth 2
                        						label .slots.f.text.$c.qye$c -text $slotque($c) -width 10 -bg "light blue" -relief sunken -borderwidth 2
                        						label .slots.f.text.$c.qavail$c -text $slotqavail($c) -width 10 -bg "light blue" -relief sunken -borderwidth 2
                        						label .slots.f.text.$c.cps$c -text $slotcps($c) -width 10 -bg "light blue" -relief sunken -borderwidth 2
                        						label .slots.f.text.$c.files$c -text [string range $slotfiles($c) 0 14] -width 15 -bg "light blue" -relief sunken -borderwidth 2
                							pack .slots.f.text.$c -fill y -expand y
                        						pack .slots.f.text.$c.but$c .slots.f.text.$c.send$c .slots.f.text.$c.savail$c .slots.f.text.$c.time$c .slots.f.text.$c.qye$c .slots.f.text.$c.qavail$c .slots.f.text.$c.cps$c  .slots.f.text.$c.files$c -side left -fill both -expand y
									# update
								}
							}
							set flag 1
						}
					}
				}
				if {!$flag} {
					incr mp3tool(totalslots)
					set slotname($mp3tool(totalslots)) $name
					set slotsend($mp3tool(totalslots)) $send
					set slotsavail($mp3tool(totalslots)) $savail
					set slottime($mp3tool(totalslots)) $time
					set slotqavail($mp3tool(totalslots)) $qavail
					set slotque($mp3tool(totalslots)) $que
					set slotcps($mp3tool(totalslots)) $cps
					set slotfiles($mp3tool(totalslots)) $files
					set slotexp($mp3tool(totalslots)) [expr $seconds + 900]
				}
			} else {
				incr mp3tool(totalslots)
				set slotname($mp3tool(totalslots)) $name
				set slotsend($mp3tool(totalslots)) $send
				set slotsavail($mp3tool(totalslots)) $savail
				set slottime($mp3tool(totalslots)) $time
				set slotqavail($mp3tool(totalslots)) $qavail
				set slotque($mp3tool(totalslots)) $que
				set slotcps($mp3tool(totalslots)) $cps
				set slotfiles($mp3tool(totalslots)) $files
				set slotexp($mp3tool(totalslots)) [expr $seconds + 900]
			}
		}
		"CPS" {
			set mp3tool(totalcps) [string range $input [expr [string first " " $input] +1] end]
			if {[winfo exists .server]} {
				.server.que.max.s.l configure -text "$mp3tool(totalcps) [Trans cps_in_use]"
			}
		}
		default {
			if {$mp3tool(debug)} {
				.text insert end "Unknown Operation $input\n"
				.text see end
			}
		}
	}
}

proc SendMSG {who msg} {
	global sock mp3tool
	if {$mp3tool(debug)} {
		.text insert end "-> MSG $who $msg\n"
		.text see end
	}
	.mp3.scrlx.act.r configure -image onright
	catch {
		puts $sock "MSG $who $msg"
		flush $sock
	} error
	if {[string length $error] > 4} {
		ErrorNotify "SendMSG" $error
	}
	if {!$mp3tool(offright)} {
		set mp3tool(offright) 1
		after 200 OffRight
	}
}

proc CancelDCC {who file} {
	global sock mp3tool
	if {$mp3tool(debug)} {
		.text insert end "-> KILL $who $file\n"
		.text see end
	}
	.mp3.scrlx.act.r configure -image onright
	catch {
		puts $sock "KILL $who [HasServerFile $file]"
		flush $sock
	} error
	if {[string length $error] > 4} {
		ErrorNotify "CancelDCC" $error
	}
	if {!$mp3tool(offright)} {
		set mp3tool(offright) 1
		after 200 OffRight
	}
}

proc SendCTCP {who msg type} {
	global sock mp3tool
	if {$mp3tool(debug)} {
		.text insert end "-> CTCP $who $type $msg\n"
		.text see end
	}
	.mp3.scrlx.act.r configure -image onright
	catch {
		puts $sock "CTCP $who $type $msg"
		flush $sock
	} error
	if {[string length $error] > 4} {
		ErrorNotify "SendCTCP" $error
	}
	if {!$mp3tool(offright)} {
		set mp3tool(offright) 1
		after 200 OffRight
	}
}

proc SendIGNORE {who} {
	global sock mp3tool
	if {$mp3tool(debug)} {
		.text insert end "-> IGNORE $who\n"
		.text see end
	}
	.mp3.scrlx.act.r configure -image onright
	catch {
		puts $sock "IGNORE $who"
		flush $sock
	} error
	if {[string length $error] > 4} {
		ErrorNotify "SendIGNORE" $error
	}
	if {!$mp3tool(offright)} {
		set mp3tool(offright) 1
		after 200 OffRight
	}
}

proc SendFILE {who what} {
	global sock mp3tool
	if {$mp3tool(debug)} {
		.text insert end "-> SEND $who \"$what\"\n"
		.text see end
	}
	.mp3.scrlx.act.r configure -image onright
	catch {
		puts $sock "SEND $who $what"
		flush $sock
	} error
	if {[string length $error] > 4} {
		ErrorNotify "SendIGNORE" $error
	}
	if {!$mp3tool(offright)} {
		set mp3tool(offright) 1
		after 200 OffRight
	}
}

proc SendCPS { } {
	global sock mp3tool
	if {$mp3tool(debug)} {
		.text insert end "-> CPS\n"
		.text see end
	}
	.mp3.scrlx.act.r configure -image onright
	catch {
		puts $sock "CPS"
		flush $sock
	} error
	if {[string length $error] > 4} {
		ErrorNotify "SendCPS" $error
	}
	if {!$mp3tool(offright)} {
		set mp3tool(offright) 1
		after 200 OffRight
	}
}

proc DCCStatus { who file qn} {
	global sock quepercent mp3tool quefile

	fileevent $sock readable {}
	if {$mp3tool(debug)} {
		.text insert end "-> STATUS $who [HasServerFile $file]\n"
		.text see end
	}
	.mp3.scrlx.act.r configure -image onright
	catch {
		puts $sock "STATUS $who [HasServerFile $file]"
		flush $sock
	} error
	if {[string length $error] > 4} {
		ErrorNotify "DCCStatus" $error
	}
	if {!$mp3tool(offright)} {
		set mp3tool(offright) 1
		after 200 OffRight
	}
	set gop 0
	while {!$gop} {
		.mp3.scrlx.act.l configure -image onleft
		set input ""
		catch {gets $sock input} error
		if {[string length $error] > 4} {
			ErrorNotify "DCCStatus" $error
		}
		if {[string first "rror" $error] != -1} {
			return 1
		}
		if {$mp3tool(debug)} {
			.text insert end "<- $input\n"
			.text see end
		}
		set op [string range $input 0 [expr [string first " " $input] -1]]
		switch -exact $op {
			"STATUS" {
				set work [string range $input [expr [string first " " $input] +1] end]
				set iwho [string range $work 0 [expr [string first " " $work] -1]]
				set work [string range $work [expr [string first " " $work] +1] end]
				set status [string range $work 0 [expr [string first " " $work] -1]]
				set work [string range $work [expr [string first " " $work] +1] end]
				set percent [string range $work 0 [expr [string first " " $work] -1]]
				set ifile [string range $work [expr [string first " " $work] +1] end]
				set gop 1
				fileevent $sock readable InPut
				if {$percent != ""} {
					set quepercent($qn) $percent
				}
				switch -exact $status {
					"SENDING" {
						return 1
					}
					"Active" {
						return 1
					}
					"WAITING" {
						return 0
					}
					"Waiting" {
						return 0
					}
					"DONE" {
						set inusebyother 0
						catch {
						for {set d 0} {$d < $mp3tool(quecount)} {incr d} {
							if {$quefile($d) == $quefile($qn) && $d != $qn} {
								set inusebyother 1
							}
						}} error
						if {[string length $error] > 4} {
							ErrorNotify "DCCStatus" $error
						}
						if {[file exists "$mp3tool(dir)/tmp/$file"] && !$inusebyother} {
							if {"$mp3tool(dir)/tmp/$file" != "$mp3tool(dir)/tmp/"} {
								catch {file delete "$mp3tool(dir)/tmp/$file"} error
								if {[string length $error] > 4} {
									ErrorNotify "DCCStatus" $error
								}
							}
						}
						return 2
					}
					"ERRORDONE" {
						set inusebyother 0
						catch {
						for {set d 0} {$d < $mp3tool(quecount)} {incr d} {
							if {$quefile($d) == $quefile($qn) && $d != $qn} {
								set inusebyother 1
							}
						}} error
						if {[string length $error] > 4} {
							ErrorNotify "DCCStatus" $error
						}
						if {[file exists "$mp3tool(dir)/tmp/$file"] && !$inusebyother} {
							catch {file delete "$mp3tool(dir)/tmp/$file"} error
							if {[string length $error] > 4} {
								ErrorNotify "DCCStatus" $error
							}
						}
						return 3
					}
				}
				set inusebyother 0
				catch {
				for {set d 0} {$d < $mp3tool(quecount)} {incr d} {
					if {$quefile($d) == $quefile($qn) && $d != $qn} {
						set inusebyother 1
					}
				}} error
				if {[string length $error] > 4} {
					ErrorNotify "DCCStatus" $error
				}
				if {[file exists "$mp3tool(dir)/tmp/$file"] && !$inusebyother} {
					catch {file delete "$mp3tool(dir)/tmp/$file"} error
					if {[string length $error] > 4} {
						ErrorNotify "DCCStatus" $error
					}
				}
				return 3
			}
			default {PrInPut $input}
		}
		if {!$mp3tool(offleft)} {
			set mp3tool(offleft) 1
			after 200 OffLeft
		}
	}
}
