proc ToggleAutoPlay {} {
	global mp3tool

	if $mp3tool(autoplay) {
		set mp3tool(autoplay) 0
	} else {
		set mp3tool(autoplay) 1
		BlinkAutoPlay
	}
}

proc BlinkAutoPlay {} {
	global mp3tool

	if $mp3tool(autoplay) {
		if [winfo exists .server] {
			if $mp3tool(ap_blink) {
				.server.que.max.files.s.scale configure \
					-label [Trans auto_play_on] -fg black
				set mp3tool(ap_blink) 0
			} else {
				.server.que.max.files.s.scale configure \
					-label [Trans auto_play_on] -fg red
				set mp3tool(ap_blink) 1
			}
		}
		after 400 BlinkAutoPlay
	} else {
		if [winfo exists .server.que.max.files.s.scale] {
			.server.que.max.files.s.scale configure \
				-label [Trans send_frequency] -fg black
		}
	}
}

proc DrawServerWindow { } {
	global serving statusfile sends tcl_platform
	global quebutton mp3tool connections
	
	if {$mp3tool(chan) == "--SETMEUP--"} {
		if [winfo exists .error] {destroy .error}
		toplevel .error
		wm title .error "MP3Tool [Trans by] Cruise - [Trans error]!!"
		ErrorIcon .error
		label .error.l -text [Trans you_have_not_entered_a_channel_name]
		label .error.ll -text [Trans enter_one_in_the_main_window]
		button .error.b -text [Trans ok] -command {destroy .error}
		pack .error.l
		pack .error.ll
		pack .error.b
		return
	}
	if {$connections == 0} {
		if [winfo exists .error] {destroy .error}
		toplevel .error
		wm title .error "MP3Tool [Trans by] Cruise - [Trans error]!!"
		ErrorIcon .error
		label .error.l -text [Trans mp3tool_is_not_connected]
		label .error.ll -text [Trans type_mp3start_in_your_irc_client]
		button .error.b -text [Trans ok] -command {destroy .error}
		pack .error.l
		pack .error.ll
		pack .error.b
		return
	}
	if {[file exists $mp3tool(dir)/MP3Tool.Que]} {
		if [winfo exists .error] {destroy .error}
		toplevel .error
		wm title .error "MP3Tool [Trans by] Cruise - [Trans que_file_found]"
		ErrorIcon .error
		label .error.l -text [Trans a_saved_que_file_has_been_detected]
		label .error.ll -text [Trans would_you_like_to_load_this_que_now]
		label .error.lll -fg red -text [Trans answering_no_will_erase_this_saved_que]
		button .error.a -text [Trans yes] -command {UseQueFile 1} -activeforeground red
		button .error.b -text [Trans no] -command {UseQueFile 0} -activeforeground red
		pack .error.l
		pack .error.ll
		pack .error.lll
		pack .error.a .error.b -side left -fill both -expand y
		return
	}
	set nick $mp3tool(nick)
	if ![winfo exists .server] {
		
		toplevel .server
		wm title .server "MP3Tool [Trans by] Cruise - MP3 [Trans server]"
		frame .server.top -relief sunken
		frame .server.sep -relief raised -bg "light blue"
		frame .server.sep.lists -relief sunken -borderwidth 2
		frame .server.sep.files -relief sunken -borderwidth 2
		frame .server.sep.grand -relief sunken -borderwidth 2
		frame .server.sep.find -relief sunken -borderwidth 2
		frame .server.buttons
		frame .server.buttons.ctcp -relief raised -bg "light blue" -borderwidth 2
		frame .server.buttons.msg -relief raised -bg "light blue" -borderwidth 2
		frame .server.buttons.color -relief raised -bg "light blue" -borderwidth 2
		frame .server.buttons.find -relief raised -bg "light blue" -borderwidth 2
		frame .server.buttons.list -relief raised -bg "light blue" -borderwidth 2
		frame .server.que
		frame .server.que.max -relief sunken -bg "light blue"  -borderwidth 2
		frame .server.que.max.files -bg "light blue" -relief raised
		frame .server.que.max.s
		scale .server.que.max.s.s -orient horizontal -from 0 -to $mp3tool(quemax) \
			-variable mp3tool(sendmax) -label [Trans send_slots] -relief raised \
			-bg "light blue" -borderwidth 2
		button .server.que.max.s.l -bg "light blue" -activeforeground "red" \
			-activebackground "light blue" -text "0 [Trans cps_in_use]" \
			-command SendCPS
		frame .server.que.max.q
		scale .server.que.max.q.s -orient horizontal -from 0 -to 30 \
			-variable mp3tool(quemax) -label [Trans que_slots] -relief raised \
			-bg "light blue" -borderwidth 2 -command ResetSendSlots
		button .server.que.max.q.b -bg "light blue" \
			-text [Trans setup_que] -activeforeground red \
			-activebackground "light blue" -command SetUpQue
		frame .server.que.max.files.s
		frame .server.que.max.files.m
 		scale .server.que.max.files.s.scale -orient horizontal -from 1 -to 30 \
			-variable mp3tool(freq) -label [Trans send_frequency] -bg "light blue" \
			-relief raised  -borderwidth 2
 		scale .server.que.max.files.s.scaleb -orient horizontal -from 0 -to 60 \
			-variable mp3tool(sfreq) -label [Trans special_frequency] -bg "light blue" \
			-relief raised  -borderwidth 2
		button .server.que.max.files.m.a -bg "light blue" \
			-text [Trans set_special_msg] -activeforeground red \
			-activebackground "light blue" -command SetSpecial
		label .server.que.max.files.m.b -bg "light blue" -text "$mp3tool(totalfiles) [Trans files]" -relief raised -borderwidth 2
		frame .server.que.a
		frame .server.que.b
		frame .server.que.c
		frame .server.que.d
		frame .server.que.e
		frame .server.que.f
		frame .server.que.g
		frame .server.que.h
		frame .server.que.i
		frame .server.que.j
		label .server.sep.lists.l -bg "light blue"
		label .server.sep.files.l -bg "light blue"
		label .server.sep.grand.l -bg "light blue"
		label .server.sep.find.l -bg "light blue"
		button .server.que.a.1 -width 20 -command {QueButton 0}
		button .server.que.a.2 -width 20 -command {QueButton 1}
		button .server.que.a.3 -width 20 -command {QueButton 2}
		button .server.que.b.1 -width 20 -command {QueButton 3}
		button .server.que.b.2 -width 20 -command {QueButton 4}
		button .server.que.b.3 -width 20 -command {QueButton 5}
		button .server.que.c.1 -width 20 -command {QueButton 6}
		button .server.que.c.2 -width 20 -command {QueButton 7}
		button .server.que.c.3 -width 20 -command {QueButton 8}
		button .server.que.d.1 -width 20 -command {QueButton 9}
		button .server.que.d.2 -width 20 -command {QueButton 10}
		button .server.que.d.3 -width 20 -command {QueButton 11}
		button .server.que.e.1 -width 20 -command {QueButton 12}
		button .server.que.e.2 -width 20 -command {QueButton 13}
		button .server.que.e.3 -width 20 -command {QueButton 14}
		button .server.que.f.1 -width 20 -command {QueButton 15}
		button .server.que.f.2 -width 20 -command {QueButton 16}
		button .server.que.f.3 -width 20 -command {QueButton 17}
		button .server.que.g.1 -width 20 -command {QueButton 18}
		button .server.que.g.2 -width 20 -command {QueButton 19}
		button .server.que.g.3 -width 20 -command {QueButton 20}
		button .server.que.h.1 -width 20 -command {QueButton 21}
		button .server.que.h.2 -width 20 -command {QueButton 22}
		button .server.que.h.3 -width 20 -command {QueButton 23}
		button .server.que.i.1 -width 20 -command {QueButton 24}
		button .server.que.i.2 -width 20 -command {QueButton 25}
		button .server.que.i.3 -width 20 -command {QueButton 26}
		button .server.que.j.1 -width 20 -command {QueButton 27}
		button .server.que.j.2 -width 20 -command {QueButton 28}
		button .server.que.j.3 -width 20 -command {QueButton 29}
		label .server.buttons.ctcp.txt -text [Trans ctcp] \
			-bg "light blue"
		checkbutton .server.buttons.ctcp.but -variable sends(CTCP) \
			-offvalue 0 -bg "light blue" -activeforeground "light blue" -highlightbackground "light blue" -highlightcolor "light blue"
		set m .server.buttons.msg.txt.menu
		menubutton .server.buttons.msg.txt -bg "light blue" \
			-activebackground "light blue" -activeforeground "red" \
			-menu $m -text [Trans channel] -relief raised -borderwidth 2
		menu $m

		# Fucking Windows!
		set platform [array get tcl_platform platform]
		set od [pwd]
		if {$platform == "platform unix"} {
			cd $mp3tool(dir)/styles
		} else {
			set drive [string range $mp3tool(dir) 0 1]
			set folder "[string range $mp3tool(dir) 2 end]/styles"
			cd $drive
			cd $folder
		}
		foreach style [glob -nocomplain *] {
			$m add checkbutton -label "$style" \
			-command "set sends(STYLE) $style" \
			-onvalue $style -variable sends(STYLE)
		}
		if {$platform == "platform unix"} {
			cd $od
		} else {
			set drive [string range $od 0 1]
			set folder [string range $od 2 end]
			cd $drive
			cd $folder
		}


		checkbutton .server.buttons.msg.but -variable sends(CHAN)  \
			-offvalue 0 -bg "light blue" -activeforeground "light blue" -highlightbackground "light blue" -highlightcolor "light blue"
		label .server.buttons.color.txt -text [Trans colorize] \
			-bg "light blue"
		checkbutton .server.buttons.color.but -variable sends(COLOR) \
			-offvalue 0 -bg "light blue" -activeforeground "light blue" -highlightbackground "light blue" -highlightcolor "light blue"
		label .server.buttons.find.txt -text [Trans @find] \
			-bg "light blue"
		checkbutton .server.buttons.find.but -variable sends(FIND) \
			-offvalue 0 -bg "light blue" -activeforeground "light blue" -highlightbackground "light blue" -highlightcolor "light blue"
		label .server.buttons.list.txt -text "@$nick" \
			-bg "light blue"
		checkbutton .server.buttons.list.but -variable sends(LIST)  \
			-offvalue 0 -bg "light blue" -activeforeground "light blue" -highlightbackground "light blue" -highlightcolor "light blue"
		button .server.buttons.save -image floppy -command SaveQue
		button .server.buttons.send -image send -command SendToChan
		button .server.buttons.mouth -image mouth -command SendToQue
		button .server.buttons.help -image help -command MP3ToolHelp
		button .server.buttons.configure -image configure -command DrawConfigureWindow
		button .server.buttons.new -image nonew -command StartStopServing
		button .server.top.play -image play -command { PlaySelected [.server.top.entry get] }
		button .server.top.pick -image choose -command {SelectOwnList}
		entry .server.top.entry -width 62 -relief sunken -bg black \
                        -fg "light green"
		pack .server.top -fill both -expand y
		pack .server.sep -fill both -expand y
		pack .server.sep.find .server.sep.lists .server.sep.files .server.sep.grand -side left -fill both -expand y
		pack .server.buttons -fill both -expand y
		pack .server.buttons.ctcp .server.buttons.msg .server.buttons.color .server.buttons.find  .server.buttons.list -side left -fill both -expand y
		pack .server.buttons.ctcp.txt .server.buttons.ctcp.but -side right
		pack .server.buttons.msg.txt .server.buttons.msg.but -side right
		pack .server.buttons.color.txt .server.buttons.color.but -side right
		pack .server.buttons.find.txt .server.buttons.find.but -side right
		pack .server.buttons.list.txt .server.buttons.list.but -side right
		pack .server.que -fill both -expand y
		pack .server.que.max -fill both -expand y
		pack .server.que.max.s .server.que.max.files .server.que.max.q -side left -fill both -expand y
		pack .server.que.max.s.s -side top -fill x -expand y
		pack .server.que.max.s.l -side bottom -fill both -expand n
		pack .server.que.max.q.s -side top -fill both -expand y
		pack .server.que.max.q.b -side bottom -fill both -expand y
		pack .server.que.max.files.s -fill both -expand y
		pack .server.que.max.files.s.scale .server.que.max.files.s.scaleb  -side left -fill x -expand y
		pack .server.que.max.files.m -fill both -expand y
		pack .server.que.max.files.m.a -side right
		pack .server.que.max.files.m.b -fill both -expand y
		pack .server.que.a  -fill both -expand y
		pack .server.que.b  -fill both -expand y
		pack .server.que.c  -fill both -expand y
		pack .server.que.d  -fill both -expand y
		pack .server.que.e  -fill both -expand y
		pack .server.que.f  -fill both -expand y
		pack .server.que.g  -fill both -expand y
		pack .server.que.h  -fill both -expand y
		pack .server.que.i  -fill both -expand y
		pack .server.que.j  -fill both -expand y
		pack .server.top.pick .server.top.play .server.top.entry -side left -expand y -fill both
		pack .server.sep.find.l -fill both -expand y
		pack .server.sep.lists.l -fill both -expand y
		pack .server.sep.files.l -fill both -expand y
		pack .server.sep.grand.l -fill both -expand y
		pack .server.buttons.save .server.buttons.send .server.buttons.mouth .server.buttons.help .server.buttons.configure .server.buttons.new -side right
		pack .server.que.a.1 .server.que.a.2 .server.que.a.3 -side left -fill x -expand y
		if {$mp3tool(quemax) > 3} {
			pack .server.que.b.1 .server.que.b.2 .server.que.b.3 -side left -fill x -expand y
		}
		if {$mp3tool(quemax) > 6} {
			pack .server.que.c.1 .server.que.c.2 .server.que.c.3 -side left -fill x -expand y
		}
		if {$mp3tool(quemax) > 9} {
			pack .server.que.d.1 .server.que.d.2 .server.que.d.3 -side left -fill x -expand y
		}
		if {$mp3tool(quemax) > 12} {
			pack .server.que.e.1 .server.que.e.2 .server.que.e.3 -side left -fill x -expand y
		}
		if {$mp3tool(quemax) > 15} {
			pack .server.que.f.1 .server.que.f.2 .server.que.f.3 -side left -fill x -expand y
		}
		if {$mp3tool(quemax) > 18} {
			pack .server.que.g.1 .server.que.g.2 .server.que.g.3 -side left -fill x -expand y
		}
		if {$mp3tool(quemax) > 21} {
			pack .server.que.h.1 .server.que.h.2 .server.que.h.3 -side left -fill x -expand y
		}
		if {$mp3tool(quemax) > 24} {
			pack .server.que.i.1 .server.que.i.2 .server.que.i.3 -side left -fill x -expand y
		}
		if {$mp3tool(quemax) > 27} {
			pack .server.que.j.1 .server.que.j.2 .server.que.j.3 -side left -fill x -expand y
		}
		wm resizable .server 0 0
		if {$platform == "platform unix"} {
			wm iconbitmap .server @$mp3tool(dir)/images/server.xbm
		}
	set quebutton(0)  .server.que.a.1
	set quebutton(1)  .server.que.a.2
	set quebutton(2)  .server.que.a.3
	set quebutton(3)  .server.que.b.1
	set quebutton(4)  .server.que.b.2
	set quebutton(5)  .server.que.b.3
	set quebutton(6)  .server.que.c.1
	set quebutton(7)  .server.que.c.2
	set quebutton(8)  .server.que.c.3
	set quebutton(9)  .server.que.d.1
	set quebutton(10) .server.que.d.2
	set quebutton(11) .server.que.d.3
	set quebutton(12)  .server.que.e.1
	set quebutton(13)  .server.que.e.2
	set quebutton(14)  .server.que.e.3
	set quebutton(15)  .server.que.f.1
	set quebutton(16)  .server.que.f.2
	set quebutton(17)  .server.que.f.3
	set quebutton(18)  .server.que.g.1
	set quebutton(19)  .server.que.g.2
	set quebutton(20)  .server.que.g.3
	set quebutton(21)  .server.que.h.1
	set quebutton(22)  .server.que.h.2
	set quebutton(23)  .server.que.h.3
	set quebutton(24)  .server.que.i.1
	set quebutton(25)  .server.que.i.2
	set quebutton(26)  .server.que.i.3
	set quebutton(27)  .server.que.j.1
	set quebutton(28)  .server.que.j.2
	set quebutton(29)  .server.que.j.3
		if {$serving} {.server.buttons.new configure -image yesnew}
	}
	bind .server.que.max.files.s.scaleb <ButtonRelease> {StartSpecial}
	if {$mp3tool(totalfiles) <= 0} {
		CreateListQuestion 1
	}
	if $mp3tool(autoplay) BlinkAutoPlay
}

proc ResetSendSlots {what} {
	.server.que.max.s.s configure -to $what
}

proc UseQueFile {yesno} {
	global mp3tool queuser quecount questatus quefile questart
	global quepercent

	if {[winfo exists .error]} {destroy .error}
	if {$yesno} {
		set quecount 0
		set queuser(0) "Empty List"
		set infile [open $mp3tool(dir)/MP3Tool.Que r]
		while {[eof $infile] != 1} {
			gets $infile input
			if {[eof $infile] != 1} {
				set statuss [string range $input 0 0]
				set work [string range $input 1 end]
				set queuser($quecount) [string range $work 0 [expr [string first " " $work] -1]]
				set quefile($quecount) [string range $work [expr [string first " " $work] +1] end]
				set questart($quecount) [clock seconds]
				set quepercent($quecount) 0
				switch -exact $statuss {
					W	{set questatus($quecount) "Waiting"}
					S	{set questatus($quecount) "Sending"}
					D	{set questatus($quecount) "Done"}
					E	{set questatus($quecount) "Empty List"}
					I	{set questatus($quecount) "InQue"}
					default	{set questatus($quecount) "InQue"}
				}
				incr quecount
			}
		}
		close $infile
	}
	file delete $mp3tool(dir)/MP3Tool.Que
	DrawServerWindow
	if {$yesno} {QueProcess}
}

proc SetUpQue {} {
	global mp3tool
	if ![winfo exists .setupque] {
		toplevel .setupque
                wm title .setupque "MP3Tool [Trans by] Cruise - [Trans set_que_properties]"
		label .setupque.infoa -text [Trans these_settings_are_per_user] \
			-relief raised  -borderwidth 2 -bg "light blue"
		frame .setupque.s
 		scale .setupque.s.scalea -orient horizontal -from 1 -to 30 \
			-variable mp3tool(MAXINSEND) -label [Trans max_files_sending] -bg "light blue" \
			-relief raised  -borderwidth 2 -length 180
 		scale .setupque.s.scaleb -orient horizontal -from 1 -to 30 \
			-variable mp3tool(MAXINQUE) -label [Trans max_files_in_que] -bg "light blue" \
			-relief raised  -borderwidth 2 -length 180
		button .setupque.dismiss -bg "light blue" -activebackground "light blue" -activeforeground "red" -command {destroy .setupque} -text [Trans dismiss]
		pack .setupque.infoa -fill both -expand y
		pack .setupque.s -fill both -expand y
		pack .setupque.dismiss -fill both -expand y
		pack .setupque.s.scalea .setupque.s.scaleb -side left -fill both -expand y
	} else {
		destroy .setupque
		update
		SetUpQue
	}
}

proc Offers { } {
}

proc SetSpecial {} {
	global sends
        if ![winfo exists .setspecial] {
                toplevel .setspecial
                wm title .setspecial "MP3Tool [Trans by] Cruise - [Trans set_special_msg]"
                entry .setspecial.what -width 50 -relief sunken
                button .setspecial.set -text [Trans set] -bg "light blue" \
                        -activeforeground red \
                        -activebackground "light blue" \
                        -command {
				set sends(SPECIAL) [.setspecial.what get]
				destroy .setspecial
				update
				StartSpecial
			}
                pack .setspecial.set -side left
                pack .setspecial.what -side right -fill both -expand y
                bind .setspecial <Return> { set sends(SPECIAL) [.setspecial.what get] }
		if {$sends(SPECIAL) != ""} {.setspecial.what insert end $sends(SPECIAL)}
        } else {
                destroy .setspecial
                update
                SetSpecial
                return
        }
}

proc StartSpecial {} {
	global mp3tool sends
	if {$mp3tool(SPECIAL)} {return}
	if {$sends(SPECIAL) == ""} {return}
	if {$mp3tool(sfreq) == 0} {return}
	SpecialEvent
}

proc SpecialEvent {} {
	global mp3tool sends uservar

	set mp3tool(SPECIAL) 1
	if {$sends(SPECIAL) != ""} {
		SendMSG $mp3tool(chan) [subst $sends(SPECIAL)]
	}
	if {$mp3tool(sfreq) != 0}  {
		after [expr $mp3tool(sfreq) * 60000] SpecialEvent
	} else {
		set MP3tool(SPECIAL) 0
	}
}

proc StartStopServing { } {
	global serving sends mp3tool

	if {$serving} {
		.server.buttons.new configure -image nonew
		set serving 0
	} else {
		.server.buttons.new configure -image yesnew
		set serving 1
		set mp3tool(mp3tool(lastoffer)) [expr int(rand() * $mp3tool(totalfiles))]
		CreateListQuestion 0
		if {!$sends(TIMERFLAG)} {
			ServerEvents
		}
	}
}

proc CreateListQuestion {force} {
	global filelist

	if ![file exists $filelist] {
		set outfile [open $filelist a]
		close $outfile
	}
	if [winfo exists .clq] {destroy .clq}
	toplevel .clq
	wm title .clq "MP3Tool [Trans by] Cruise - [Trans generate_list]?"
	frame .clq.b 
	label .clq.lll -text [Trans would_you_like_to_generate_a_new_list]
	label .clq.l -text [Trans your_current_list_was_generated]
	label .clq.ll -text [clock format [file atime $filelist]]
	button .clq.b.b -text [Trans Yes] -command {destroy .clq;CreateList} -activeforeground red
	if {$force} {
		button .clq.b.bb -text [Trans No] -command {destroy .clq;MemoryList} -activeforeground red
	} {
		button .clq.b.bb -text [Trans No] -command {destroy .clq} -activeforeground red
	}
	pack .clq.lll
	pack .clq.l
	pack .clq.ll
	pack .clq.b
	pack .clq.b.b .clq.b.bb -side left -fill both -expand y
}	

proc ServerEvents { } {
	global serving mp3tool sends sendlist 
	global mp3tool total_files grand_total quepercent
	global totfin uservar quecount queuser questatus
	global questart

	set nick $mp3tool(nick)
	update

	if { !$serving } {
		set sends(TIMERFLAG) 0
		return
	}
	
	set sends(TIMERFLAG) 1

	if {$sends(CTCP)} {
		SendCTCP $mp3tool(chan) $sendlist($mp3tool(lastoffer)) MP3
		set mp3tool(timeleftstring) "UNKNOWN"
		if {$mp3tool(client) == "epic ircII" || $mp3tool(client) == "Zircon"} {
			set mp3tool(timeleftstring) 9999999
			set seconds [clock seconds]
			if {$quecount != 0 && $queuser(0) != "Empty List"} {
				for {set c 0} {$c < $mp3tool(sendmax)} {incr c} {
					if {$questatus($c) == "Sending"} {
						if {$quepercent($c)} {
							if {[expr (100.0 - double($quepercent($c))) * double((double($seconds) - double($questart($c))) / double($quepercent($c)))] < $mp3tool(timeleftstring)} {
								set mp3tool(timeleftstring) [expr (100.0 - double($quepercent($c))) * double((double($seconds) - double($questart($c))) / double($quepercent($c)))]
							}
						}
					}
				}
			}
			if {$mp3tool(timeleftstring) != 9999999} {
				if {$mp3tool(timeleftstring) > 120.0} {
					set mp3tool(timeleftstring) [expr $mp3tool(timeleftstring) / 60]
					set time "min"
					set mp3tool(timeleftstring) [format "%0.2f%s" $mp3tool(timeleftstring) $time]
				} {
					set time "sec"
					set mp3tool(timeleftstring) [format "%0.2f%s" $mp3tool(timeleftstring) $time]
				}
			} {
				set mp3tool(timeleftstring) "UNKNOWN"
			}
		}
		if {[expr $mp3tool(sendmax) - $mp3tool(usedslots)] > 0} {
			after 2000 {SendCTCP $mp3tool(chan) "$mp3tool(sendmax) [expr $mp3tool(sendmax) - $mp3tool(usedslots)] NOW [expr $quecount - $mp3tool(usedslots)] [expr $mp3tool(quemax) - $mp3tool(sendmax)] $mp3tool(totalcps) $mp3tool(totalfiles)" SLOTS}
		} {
			after 2000 {SendCTCP $mp3tool(chan) "$mp3tool(sendmax) [expr $mp3tool(sendmax) - $mp3tool(usedslots)] $mp3tool(timeleftstring) [expr $quecount - $mp3tool(usedslots)] [expr $mp3tool(quemax) - $mp3tool(sendmax)] $mp3tool(totalcps) $mp3tool(totalfiles)" SLOTS}
		}
	}
	if {$sends(CHAN)} {
		source $mp3tool(dir)/styles/Default
		catch {source $mp3tool(dir)/styles/$sends(STYLE)} error
		if {$sends(COLOR)} {
			for {set c 1} {$c <= $color(lines)} {incr c} {
				SendMSG $mp3tool(chan) $color($c)
			}
		} else {
			for {set c 1} {$c <= $nocolor(lines)} {incr c} {
				SendMSG $mp3tool(chan) $nocolor($c)
			}
		}
	}
	if { $sends(CTCP) || $sends(CHAN) } {
		if [winfo exists .server] {
			.server.top.entry delete 0 end
			.server.top.entry insert end [HasServerFile $sendlist($mp3tool(lastoffer))]
		}
	}
	if [winfo exists .server] {
		.server.sep.find.l configure -text "$totfin [Trans finds]"
		.server.sep.lists.l configure -text "[Trans sent] $mp3tool(total_lists) [Trans lists]"
		.server.sep.files.l configure -text "[Trans sent] $total_files MP3s"
		.server.sep.grand.l configure -text "[Trans grandtotal] $grand_total MP3s"
		.server.que.max.files.m.b configure -text "$mp3tool(totalfiles) [Trans files]"
	}
	if {$mp3tool(autoplay)} {
		if {[file exists [HasServerFile $sendlist($mp3tool(lastoffer))]]} {
			set playfile [HasServerFile $sendlist($mp3tool(lastoffer))]
			set mp3tool(lastoffer) [expr int(rand() * $mp3tool(totalfiles))]
			set rate [MP3Props $playfile]
			set rate [string range $rate 0 [expr [string first " " $rate] -1]]
			if {$rate == "N/A"} {
				exec $mp3tool(x11amp) $playfile &
				after [expr $mp3tool(freq) * 60000] ServerEvents
				return
			}
			set bytes [file size $playfile]
			set minutes [expr ($bytes * 8) / $rate]
			set milli [expr ($minutes % 1000)]
			set minutes [expr $minutes / 1000]
			set seconds [expr $minutes % 60]
			set minutes [expr $minutes / 60]			
			exec $mp3tool(x11amp) $playfile &
			after [expr ($minutes * 60000) + ($seconds * 1000)] ServerEvents
		} else {
			set mp3tool(lastoffer) [expr int(rand() * $mp3tool(totalfiles))]
			after [expr $mp3tool(freq) * 60000] ServerEvents
		}
	} else {
		set mp3tool(lastoffer) [expr int(rand() * $mp3tool(totalfiles))]
		after [expr $mp3tool(freq) * 60000] ServerEvents
	}
}		

proc SaveQue {} {
	if [winfo exists .error] {destroy .error}
	toplevel .error
	wm title .error "MP3Tool [Trans by] Cruise - [Trans idle_information]"
	ErrorIcon .error
	label .error.l -text [Trans should_users_sending_be_forced_idle]
	label .error.ll -text [Trans you_should_choose_yes_if_you_are_disconnecting_from_irc]
	label .error.lll -text [Trans choosing_yes_will_allow_users_sending_to_resume]
	button .error.a -text [Trans yes] -command {ReallySaveQue 1} -activeforeground red
	button .error.b -text [Trans no] -command {ReallySaveQue 0} -activeforeground red
	pack .error.l
	pack .error.ll
	pack .error.lll
	pack .error.a .error.b -side left -fill both -expand y
}

proc ReallySaveQue {setidle} {
	global questatus questart queuser questatus
	global quefile quecount mp3tool

	set outfile [open $mp3tool(dir)/MP3Tool.Que w]
	for {set c 0} {$c < $quecount} {incr c} {
		if {$setidle} {
			puts $outfile "I$queuser($c) $quefile($c)"
		} {
			puts $outfile "[string range $questatus($c) 0 0]$queuser($c) $quefile($c)"
		}
	}
	close $outfile
	if [winfo exists .error] {destroy .error}
	toplevel .error
	wm title .error "MP3Tool [Trans by] Cruise - [Trans que_saved]"
	ErrorIcon .error
	label .error.l -text [Trans que_has_been_saved_you_will_be_prompted]
	label .error.ll -text [Trans to_load_it_when_you_restart_mp3tool]
	button .error.b -text [Trans ok] -command {destroy .error} -activeforeground red
	pack .error.l
	pack .error.ll
	pack .error.b
	return
}

proc MemoryList { } {
	global filelist serverdirs sendlist excludes
	global mp3tool slist search_index single_search_index

	set nick $mp3tool(nick)
	set wait 1
	set update_counter 1
	if ![winfo exists .create] {
		toplevel .create
		wm title .create "MP3Tool [Trans by] Cruise [Trans wait]!"
		label .create.t1 -width 30 -text [Trans please_wait]
		label .create.t2 -text [Trans loading_existing_list_into_memory]
		label .create.i -image wait$wait
		label .create.f -text [Trans loading]
		pack .create.t1 -fill both -expand y
		pack .create.t2 -fill both -expand y
		pack .create.i -fill both -expand y
		pack .create.f -fill both -expand y
		update
	} {
		.create.f configure -text [Trans loading]
	}
	set infile [open $filelist "r"]
	gets $infile
	gets $infile
	gets $infile
	gets $infile
	gets $infile
	set c 0
	set mp3tool(totalfiles) 0
	while {[eof $infile] != 1} {
		if ![winfo exists .create] {
			toplevel .create
			wm title .create "MP3Tool [Trans by] Cruise [Trans wait]!"
			label .create.t1 -width 30 -text [Trans please_wait]
			label .create.t2 -text [Trans loading_existing_list_into_memory]
			label .create.i -image wait$wait
			label .create.f -text [Trans loading]
			pack .create.t1 -fill both -expand y
			pack .create.t2 -fill both -expand y
			pack .create.i -fill both -expand y
			pack .create.f -fill both -expand y
			update
		} {
			.create.f configure -text [Trans files]
		}
		gets $infile input
		set brkpnt [string first ".mp3" [string tolower $input]]
		set file [string range $input [expr [string first " " $input] +1] [expr $brkpnt + 3]]
		set sendlist($c) $file
		incr c
		incr mp3tool(totalfiles)
		if [winfo exists .create] {
			incr wait
			incr update_counter
			if {$wait > 19} {set wait 1}
			.create.i configure -image wait$wait
			.create.f configure -text "$mp3tool(totalfiles) [Trans files]"
			if {$update_counter % 100} { 
				update idletasks
			} {
				update
			}
		}
	}
	close $infile
	if [winfo exists .server] {
		.server.que.max.files.m.b configure -text "$mp3tool(totalfiles) [Trans files]"
	}
	for {set c 0} {$c < $mp3tool(totalfiles)} {incr c} {
		if ![winfo exists .create] {
			toplevel .create
			wm title .create "MP3Tool [Trans by] Cruise [Trans wait]!"
			label .create.t1 -width 30 -text [Trans please_wait]
			label .create.t2 -text [Trans loading_existing_list_into_memory]
			label .create.i -image wait$wait
			label .create.f -text [Trans search_index_creation]
			pack .create.t1 -fill both -expand y
			pack .create.t2 -fill both -expand y
			pack .create.i -fill both -expand y
			pack .create.f -fill both -expand y
			update
		} {
			.create.f configure -text [Trans search_index_creation]
		}
		set slist($c) [string tolower $sendlist($c)]
		if {[info exists search_index([string range $slist($c) 0 1])] == 0} {
			set search_index([string range $slist($c) 0 1]) $c
		}
		if {[info exists single_search_index([string range $slist($c) 0 0])] == 0} {
			set single_search_index([string range $slist($c) 0 0]) $c
		}
		if [winfo exists .create] {
			incr wait
			incr update_counter
			if {$wait > 19} {set wait 1}
			.create.i configure -image wait$wait
			if {$update_counter % 100} { 
				update idletasks
			} {
				update
			}
		}
	}
	if [winfo exists .create] {destroy .create}
	set mp3tool(lastoffer) 1
}

proc CreateList { } {
	global filelist serverdirs sendlist excludes
	global mp3tool slist search_index single_search_index

	set nick $mp3tool(nick)
	set od [pwd]
	set ptn *
	set masterlist {}
	set wait 1
	set update_counter 1
	foreach dir $serverdirs {
		if ![winfo exists .create] {
			toplevel .create
			wm title .create "MP3Tool [Trans by] Cruise [Trans wait]!"
			label .create.t1 -width 30 -text [Trans please_wait]
			label .create.t2 -text [Trans creating_list]
			label .create.i -image wait$wait
			label .create.f -text [Trans initial_file_scan]
			pack .create.t1 -fill both -expand y
			pack .create.t2 -fill both -expand y
			pack .create.i -fill both -expand y
			pack .create.f -fill both -expand y
			update
		} {
			.create.f configure -text [Trans initial_file_scan]
		}
		# Fucking windows!
		if {[string range $dir 1 1] == ":"} {
			set drive [string range $dir 0 1]
			set folder [string range $dir 2 end]
			cd $drive
			cd $folder
		} else {
			cd $dir
		}
		set files [lsort -dictionary [glob -nocomplain $ptn]]
		foreach file $files {
			if {[file extension $file] == ".mp3"} {
				if {[lsearch -exact $excludes $file] == -1} {
					lappend masterlist $file
				}
				if [winfo exists .create] {
					incr wait
					incr update_counter
					if {$wait > 19} {set wait 1}
					.create.i configure -image wait$wait
					if {$update_counter % 100} { 
						update idletasks
					} {
						update
					}
				}
			}
		}
	}
	set outfile [open $filelist "w"]
	puts $outfile "List generated [clock format [clock seconds]]\r"
	puts $outfile "List generated by MP3Tool for $mp3tool(client) v$mp3tool(version) written by Cruise <cruise@drunkenbastards.org>\r"
	puts $outfile "For Information on MP3Tool visit http://www.daytona.com/mp3tool\r"
	puts $outfile "To get any of these files, just cut and pase from !$nick\r"
	puts $outfile "into the channel and you will be sent the file requested.\r\n\r"
	set masterlist [lsort -dictionary $masterlist]
	set c 0
	set mp3tool(totalfiles) 0
	foreach file $masterlist {
		if ![winfo exists .create] {
			toplevel .create
			wm title .create "MP3Tool [Trans by] Cruise [Trans wait]!"
			label .create.t1 -width 30 -text [Trans please_wait]
			label .create.t2 -text [Trans creating_list]
			label .create.i -image wait$wait
			label .create.f -text [Trans files]
			pack .create.t1 -fill both -expand y
			pack .create.t2 -fill both -expand y
			pack .create.i -fill both -expand y
			pack .create.f -fill both -expand y
			update
		} {
			.create.f configure -text "0 [Trans files]"
		}
		set sendlist($c) $file
		incr c
		incr mp3tool(totalfiles)
		if {[string length $file] <= 60} {
			puts $outfile "!$nick [format "%-60s %d KBytes" $file [expr [file size [HasServerFile $file]] / 1024]]\r"
		} else {
			puts $outfile "!$nick $file [expr [file size [HasServerFile $file]] / 1024] KBytes\r"
		}
		if [winfo exists .create] {
			incr wait
			incr update_counter
			if {$wait > 19} {set wait 1}
			.create.i configure -image wait$wait
			.create.f configure -text "$mp3tool(totalfiles) [Trans files]"
			if {$update_counter % 100} { 
				update idletasks
			} {
				update
			}
		}
	}
	close $outfile
	# Fucking windows!
	if {[string range $od 1 1] == ":"} {
		set drive [string range $od 0 1]
		set folder [string range $od 2 end]
		cd $drive
		cd $folder
	} else {
		cd $od
	}
	if [winfo exists .server] {
		.server.que.max.files.m.b configure -text "$mp3tool(totalfiles) [Trans files]"
	}
	for {set c 0} {$c < $mp3tool(totalfiles)} {incr c} {
		if ![winfo exists .create] {
			toplevel .create
			wm title .create "MP3Tool [Trans by] Cruise [Trans wait]!"
			label .create.t1 -width 30 -text [Trans please_wait]
			label .create.t2 -text [Trans creating_list]
			label .create.i -image wait$wait
			label .create.f -text [Trans search_index_creation]
			pack .create.t1 -fill both -expand y
			pack .create.t2 -fill both -expand y
			pack .create.i -fill both -expand y
			pack .create.f -fill both -expand y
			update
		} {
			.create.f configure -text [Trans search_index_creation]
		}
		set slist($c) [string tolower $sendlist($c)]
		if {[info exists search_index([string range $slist($c) 0 1])] == 0} {
			set search_index([string range $slist($c) 0 1]) $c
		}
		if {[info exists single_search_index([string range $slist($c) 0 0])] == 0} {
			set single_search_index([string range $slist($c) 0 0]) $c
		}
		if [winfo exists .create] {
			incr wait
			incr update_counter
			if {$wait > 19} {set wait 1}
			.create.i configure -image wait$wait
			if {$update_counter % 100} { 
				update idletasks
			} {
				update
			}
		}
	}
	if [winfo exists .create] {destroy .create}
}

proc QueRequest {file who} {
	global sendlist questatus questart queuser sends
	global quefile quecount mp3tool quepercent

	set nick $mp3tool(nick)
	set valid 0
	set que_scount 0
	set que_wcount 0
	for {set c 0} {$c < $quecount} {incr c} {
		if {$queuser($c) == $who} {
			if {$quefile($c) == [string trim $file]} {
				if {$sends(COLOR)} {
					SendMSG $who "\0031,1\0033[Trans request_denied] \0034$file \0033[Trans was_not_qued_because_you_already_have_it_in_my_que] \0034([Trans position] [expr ($c +1) - $mp3tool(usedslots)]) $mp3tool(color_advertisement)"
				} else {
					SendMSG $who "[Trans request_denied] $file [Trans was_not_qued_because_you_already_have_it_in_my_que] ([Trans position] [expr ($c +1) - $mp3tool(usedslots)]) $mp3tool(advertisement)"
				}
				return
			}
			if {$questatus($c) == "Sending"} {
				incr que_scount
			}
			if {$questatus($c) == "Waiting"} {
				incr que_scount
			}
			if {$questatus($c) == "InQue"} {
				incr que_wcount
			}
		}
	}
	if {$que_wcount >= $mp3tool(MAXINQUE) && $que_scount >= $mp3tool(MAXINSEND)} {
		if {$sends(COLOR)} {
			SendMSG $who "\0031,1\0033[Trans request_denied] \0034$file \0033 [Trans was_not_qued_because_you_already_have] \00304$mp3tool(MAXINQUE) \0033[Trans in_the_que_and] \00304$mp3tool(MAXINSEND) \0033[Trans sending]. $mp3tool(color_advertisement)"
		} else {
			SendMSG $who "[Trans request_denied] $file [Trans was_not_qued_because_you_already_have] $mp3tool(MAXINQUE) [Trans in_the_que_and] $mp3tool(MAXINSEND) [Trans sending]. $mp3tool(advertisement)"
		}
		return
	}
	if {$que_wcount >= $mp3tool(MAXINQUE)} {
		if {$sends(COLOR)} {
			SendMSG $who "\0031,1\0033[Trans request_denied] \0034$file \0033[Trans was_not_qued_because_you_already_have] \0034$mp3tool(MAXINQUE) \0033[Trans in_the_que]. $mp3tool(color_advertisement)"
		} else {
			SendMSG $who "[Trans request_denied] $file [Trans was_not_qued_because_you_already_have] $mp3tool(MAXINQUE) [Trans in_the_que]. $mp3tool(advertisement)"
		}
		return		
	}
	for {set c 0} {$c < $mp3tool(totalfiles)} {incr c} {
		if {[string trim $file] == $sendlist($c)} {
			set valid 1
			break
		}
	}
	if {!$valid} {
		if {$sends(COLOR)} {
			SendMSG $who "\0031,1\0033[Trans request_denied] \0034$file \0033[Trans is_not_a_valid_file_in_my_list_please_check_your_spelling_and_try_again] $mp3tool(color_advertisement)"
		} else {
			SendMSG $who "[Trans request_denied] $file [Trans is_not_a_valid_file_in_my_list_please_check_your_spelling_and_try_again] $mp3tool(advertisement)"
		}
	} else {
		if {$quecount < $mp3tool(quemax)} {
			set queuser($quecount) $who
			set questatus($quecount) "InQue"
			set questart($quecount) [clock seconds]
			if [winfo exists .queuser] {
				.queuser.status.v configure -text [Trans done]
				.queuser.time.v configure -text [clock format $questart($c) -format "%T"]
			}
			set quefile($quecount) [string trim $file]
			if {$sends(COLOR)} {
				SendMSG $who "\0031,1\0034$file \0033[Trans is_number] \00304[expr ($quecount +1) - $mp3tool(usedslots)] \0033[Trans in_my_que] \00308(\00307[expr $que_wcount + 1] \00311of \00307$mp3tool(MAXINQUE)\00308) \0038@$nick-que \0033[Trans to_view_it_or] \0038@$nick-remove \0033[Trans to_remove_it_at_any_time]. $mp3tool(color_advertisement)"
			} else {
				SendMSG $who "$file [Trans is_number] [expr ($quecount +1) - $mp3tool(usedslots)] [Trans in_my_que] ([expr $que_wcount + 1] of $mp3tool(MAXINQUE)) @$nick-que [Trans to_view_it_or] @$nick-remove [Trans to_remove_it_at_any_time]. $mp3tool(advertisement)"
			}
			if {$quecount == 0} {
				QueProcess
			}
			incr quecount
		} else {
			if {$sends(COLOR)} {
				SendMSG $who "\0031,1\0033[Trans request_denied] [Trans my_que_is_maxed_out_at] \00304$quecount \0033[Trans please_try_again_later]. $mp3tool(color_advertisement)"
			} else {
				SendMSG $who "[Trans request_denied] [Trans my_que_is_maxed_out_at] $quecount [Trans please_try_again_later]. $mp3tool(advertisement)"
			}
		}
	}
}

proc CountSends {who} {
	global queuser quecount questatus

	set que_scount 0

	for {set c 0} {$c < $quecount} {incr c} {
		if {$queuser($c) == $who} {
			if {$questatus($c) == "Sending"} {
				incr que_scount
			}
			if {$questatus($c) == "Waiting"} {
				incr que_scount
			}
		}
	}
	return $que_scount
}

proc HasServerFile { file } {
        global serverdirs mp3tool
        foreach dir $serverdirs {
                if {[file exists "$dir/$file"]} {
                        return "$dir/$file"
                }
        }
        if {[file exists "$mp3tool(dir)/tmp/$file"]} {
		return "$mp3tool(dir)/tmp/$file"
	}
        return "--"
} 

proc QueProcess { } {
        global sendlist questatus questart queuser
        global quefile quecount mp3tool quebutton
	global total_files grand_total grand_date totfin
	global quepercent sends zcps zMYcps

	if {$mp3tool(client) == "Zircon"} {
		set mp3tool(totalcps) 0
		for {set c 0} {$c < $mp3tool(sendmax)} {incr c} {
			if {$questatus($c) == "Sending"} {
				incr mp3tool(totalcps) $zcps($queuser($c))
			}
		}
		foreach who $mp3tool(zMYdownloads) {
			if {[info exists zMYcps($who)]} {
				incr mp3tool(totalcps) $zMYcps($who)
			}
		}
		if {[winfo exists .server]} {
			.server.que.max.s.l configure -text "$mp3tool(totalcps) [Trans cps_in_use]"
		}
	}

	if [winfo exists .server] {
		for {set c 0} {$c < $mp3tool(quemax)} {incr c} {
			$quebutton($c) configure -bg grey -activebackground white -text [Trans empty_-_idle]
		}
		for {set c 0} {$c < $mp3tool(sendmax)} {incr c} {
			$quebutton($c) configure -bg "orange" -activebackground "pink"
		}
	}

	if {$quecount == 0 && $queuser(0) == "Empty List"} {
		set mp3tool(quep) 0
		return
	}

	for {set c 0} {$c < $quecount} {incr c} {
		if {$c < $mp3tool(sendmax)} {
			if {$questatus($c) == "InQue"} {
				if {[CountSends $queuser($c)] >= $mp3tool(MAXINSEND)} {
					FlipThem $c
				} else {
					incr mp3tool(usedslots)
					set questatus($c) "Waiting"
					set quepercent($c) 0
					set questart($c) [clock seconds]
					if [winfo exists .queuser] {
						.queuser.status.v configure -text [Trans waiting]
						.queuser.time.v configure -text [clock format $questart($c) -format "%T"]
					}
					set what [HasServerFile $quefile($c)]
					if {[string first " " $what] != -1} {
						set ftest $what
						while {[string first "/" $ftest] != -1} {
							set ftest [string range $ftest [expr [string first "/" $ftest] +1] end]
						}
						set new_file ""
						for {set d 0} {$d < [string length $ftest]} {incr d} {
							switch -exact -- [string range $ftest $d $d] {
								" " {
									append new_file "_"
								}
								default {
									append new_file [string range $ftest $d $d]
								}
							}
						}
						set quefile($c) $new_file
						link -sym "$what" "$mp3tool(dir)/tmp/$new_file"
						set what "$mp3tool(dir)/tmp/$new_file"
					}
					SendFILE $queuser($c) $what
					if {$sends(COLOR)} {
						SendMSG $queuser($c) "\0031,1\0033[Trans sending_file]! \0034$quefile($c) \0033[Trans is_on_the_way_i_hope_you_enjoy_the_file]. $mp3tool(color_advertisement)"
					} else {
						SendMSG $queuser($c) "[Trans sending_file]! $quefile($c) [Trans is_on_the_way_i_hope_you_enjoy_the_file]. $mp3tool(advertisement)"
					}
				}
			} else {
				switch -exact [DCCStatus $queuser($c) $quefile($c) $c] {
					"0" {
						if {$mp3tool(client) == "epic ircII"} {
							if {[expr ([clock seconds] - $questart($c)) / 60] > $sends(TIMEOUT)} {
								CancelDCC $queuser($c) $quefile($c)
							}
						}
					}
					"1" {
						# Sending!
						if [winfo exists .queuser] {
							if {[.queuser.name.v cget -text] == $queuser($c)} {
								if {$quepercent($c) != 0} {
									.queuser.status.v configure -text "[Trans sending] $quepercent($c)%"
								} else {
									.queuser.status.v configure -text [Trans sending]
								}
								.queuser.time.v configure -text [clock format $questart($c) -format "%T"]
							}
						}
						if {$questatus($c) != "Sending"} {
							set questatus($c) "Sending"
							set questart($c) [clock seconds]
						}
					}
					"2" {
						# Done!
						if [winfo exists .queuser] {
							destroy .queuser
						}
						incr total_files
						if {$mp3tool(client) == "BitchX" || $mp3tool(client) == "mIRC" || $mp3tool(client) == "epic ircII"} {
							.status configure -text "[Trans finds] $totfin -- [Trans lists] $mp3tool(total_lists) -- [Trans sent] $total_files"
						}
						IncrGrandTotal
						incr mp3tool(usedslots) -1
						if {$questatus($c) != "Done"} {
							set questatus($c) "Done"
							set questart($c) [clock seconds]
							if [winfo exists .queuser] {
								.queuser.status.v configure -text [Trans done]
								.queuser.time.v configure -text [clock format $questart($c) -format "%T"]
							}
						}
						if {$sends(COLOR)} {
							SendMSG $queuser($c) "\0031,1\0033[Trans your_send_request_for] \0034$quefile($c) \0033[Trans is_complete_if_there_were_problems_you_are_welcomed_to_re-request_it_this_is_file_number]  \00304$grand_total \0033[Trans sent_since] \0034$grand_date $mp3tool(color_advertisement)"
						} else {
							SendMSG $queuser($c) "[Trans your_send_request_for] $quefile($c) [Trans is_complete_if_there_were_problems_you_are_welcomed_to_re-request_it_this_is_file_number]  $grand_total [Trans sent_since] $grand_date $mp3tool(color_advertisement)"
						}
						ShuffleQue $c
					}
					"3" {
						# ERROR Done!
						if [winfo exists .queuser] {
							destroy .queuser
						}
						if {$mp3tool(client) == "BitchX" || $mp3tool(client) == "mIRC" || $mp3tool(client) == "epic ircII"} {
							.status configure -text "[Trans finds] $totfin -- [Trans lists] $mp3tool(total_lists) -- [Trans sent] $total_files"
						}
						incr mp3tool(usedslots) -1
						if {$questatus($c) != "Done"} {
							set questatus($c) "Done"
							set questart($c) [clock seconds]
							if [winfo exists .queuser] {
								.queuser.status.v configure -text [Trans done]
								.queuser.time.v configure -text [clock format $questart($c) -format "%T"]
							}
						}
						if {$sends(COLOR)} {
							after 5000 {SendMSG {$queuser($c)} {\"\0031,1\0033[Trans your_send_request_for] \0034$quefile($c) \0033[Trans has_ended_with_an] \0034[Trans error] \0033[Trans status_you_are_welcomed_to_re-request_it]. $mp3tool(color_advertisement)\"}}
						} else {
							after 5000 {SendMSG {$queuser($c)} {\"[Trans your_send_request_for] $quefile($c) [Trans has_ended_with_an] [Trans error] [Trans status_you_are_welcomed_to_re-request_it]. $mp3tool(advertisement)\"}}
						}
						ShuffleQue $c
					}
				}
			}
		}
		if {$quecount == 0 && $queuser(0) == "Empty List"} {return}
		if [winfo exists .server] {
			if {$questatus($c) == "Sending"} {
				if {$quepercent($c) != 0} {
					$quebutton($c) configure -text "$queuser($c) [Trans sending] $quepercent($c)%"
				} else {
					$quebutton($c) configure -text "$queuser($c) [Trans sending]"
				}
			} else {
				$quebutton($c) configure -text "$queuser($c) $questatus($c)"
			}
		}
	}
	if {!$mp3tool(quep)} {
		after 4000 QueProcess
		set $mp3tool(quep) 1
	}
}

proc ShuffleQue { start } {
	global queuser
	global questatus
	global quefile
	global quecount

	set queuser($quecount) "Empty List"
	set questatus($quecount) "Empty List"
	set quefile($quecount) "Empty List"
	for {set c $start} {$c < $quecount} {incr c} {
		set queuser($c) $queuser([expr $c+1])
		set questatus($c) $questatus([expr $c+1])
		set quefile($c) $quefile([expr $c+1])
	}
	incr quecount -1
	if {$quecount < 0} {
		set quecount 0
	}
}

proc MatchUnf {who what} {
	global queuser quefile quecount

	for {set c 0} {$c < $quecount} {incr c} {
		if {$who == $queuser($c) && $what == [HasServerFile $quefile($c)]} {
			return $c
		}
	}
	return -1
}

proc FlipThem { start } {
	global queuser questatus quefile quecount mp3tool

	set newplacement 0
	for {set c [expr $start +1]} {$c < $quecount} {incr c} {
		if {[CountSends $queuser($c)] < $mp3tool(MAXINSEND)} {
			set newplacement $c
		}
	}

	if {$newplacement != 0} {
		if {$newplacement == $mp3tool(quemax)} {
			set moveuser_a $queuser($start)
			set moveuser_b $questatus($start)
			set moveuser_c $quefile($start)
			for {set c 0} {$c < [expr $quecount -1]} {incr c} {
				set queuser($c) $queuser([expr $c+1])
				set questatus($c) $questatus([expr $c+1])
				set quefile($c) $quefile([expr $c+1])
			}
			set queuser($newplacement) $moveuser_a
			set questatus($newplacement) $moveuser_b
			set quefile($newplacement) $moveuser_c
		} else {
			set moveuser_a $queuser($start)
			set moveuser_b $questatus($start)
			set moveuser_c $quefile($start)
			for {set d $start} {$d < $newplacement} {incr d} {
				set queuser($d) $queuser([expr $d+1])
				set questatus($d) $questatus([expr $d+1])
				set quefile($d) $quefile([expr $d+1])
			}
			set queuser($newplacement) $moveuser_a
			set questatus($newplacement) $moveuser_b
			set quefile($newplacement) $moveuser_c
		}
	}
}

proc IncrGrandTotal { } {
	global grand_total mp3tool

	set outfile [open $mp3tool(grand_file) "w"]
	if {$grand_total == ""} {set grand_total 0}
	incr grand_total
	puts $outfile $grand_total
	close $outfile
}

proc SetGrandTotal { } {
	global grand_total mp3tool

	if [file exists $mp3tool(grand_file)] {
		set infile [open $mp3tool(grand_file) "r"]
		gets $infile grand_total
		close $infile
	} else {
		set grand_total 0
	}
}

proc que_remove { who } {
	global queuser questart quefile questatus quecount sends

	for {set c [expr $quecount -1]} {$c >= 0} {incr c -1} {
		if {$who == $queuser($c)} {
			if {$questatus($c) == "Sending" || $questatus($c) == "Waiting"} {
				if {$sends(COLOR)} {
					SendMSG $who "\0031,1\0034$quefile($c) \0033[Trans cannot_be_removed_cancel_the_transfer_already_in_progress_to_remove_it]. $mp3tool(color_advertisement)"
				} else {
					SendMSG $who "$quefile($c) [Trans cannot_be_removed_cancel_the_transfer_already_in_progress_to_remove_it]. $mp3tool(advertisement)"
				}
				return
			}
			set questatus($c) "Done"
			set questart($c) [clock seconds]
			if [winfo exists .queuser] {
				.queuser.status.v configure -text [Trans done]
				.queuser.time.v configure -text [clock format $questart($c) -format "%T"]
			}
			if {$sends(COLOR)} {
				SendMSG $who "\0031,1\0034$quefile($c) \0033has_been_removed_sorry_that_it_didnt_work_out :) $mp3tool(color_advertisement)"
			} else {
				SendMSG $who "$quefile($c) has_been_removed_sorry_that_it_didnt_work_out :) $mp3tool(advertisement)"
			}
			ShuffleQue $c
			return
		}
	}
	if {$sends(COLOR)} {
		SendMSG $who "\0031,1\0034[Trans you_have_no_files_in_my_que]! $mp3tool(color_advertisement)"
	} else {
		SendMSG $who "[Trans you_have_no_files_in_my_que]! $mp3tool(advertisement)"
	}
}

proc que_report { who } {
	global queuser quefile questatus quecount mp3tool
	global sends

	set nick $mp3tool(nick)
	set flag 0
	set inque 0
	for {set c 0} {$c < $quecount} {incr c} {
		if {$who == $queuser($c)} {
			if {$sends(COLOR)} {
				SendMSG $who "\0031,1\0034$quefile($c) \0033[Trans is_qued_your_position_in_my_que_is] \00304[expr ($c +1) - $mp3tool(usedslots)] \0033[Trans send_mesend_me] \0038@$nick-remove \0033[Trans to_remove_it]."
			} else {
				SendMSG $who "$quefile($c) [Trans is_qued_your_position_in_my_que_is] [expr ($c +1) - $mp3tool(usedslots)] [Trans send_mesend_me] @$nick-remove [Trans to_remove_it]."
			}
			set flag 1
			incr inque
		}
	}
	if {$inque} {
		if {$sends(COLOR)} {
			SendMSG $who "\0031,1\0033[Trans you_have_a_total_of] \00304$inque \0033[Trans files_in_my_que]. $mp3tool(color_advertisement)"
		} {
			SendMSG $who "[Trans you_have_a_total_of] $inque [Trans files_in_my_que]. $mp3tool(advertisement)"
		}
	}
	if {!$flag} {
		if {$sends(COLOR)} {
			SendMSG $who "\0031,1\0033[Trans you_have_no_files_in_my_que]! $mp3tool(color_advertisement)"
		} else {
			SendMSG $who "[Trans you_have_no_files_in_my_que]! $mp3tool(advertisement)"
		}
	}
}

proc QueButton { what } {
	global queuser questatus questart quefile quecount mp3tool

	if {$what >= $quecount} {return}
	if ![winfo exists .queuser] {
		toplevel .queuser
		wm title .queuser "MP3Tool [Trans by] Cruise - $queuser($what)"
		frame .queuser.name -bg "light blue"
		frame .queuser.status -bg "light blue"
		frame .queuser.time -bg "light blue"
		frame .queuser.file -bg "light blue"
		label .queuser.name.l -bg "light blue" -text [Trans name]
		label .queuser.name.v -width 15 -relief sunken -text $queuser($what)
		label .queuser.status.l -bg "light blue" -text [Trans status]
		if {$questatus($what) == "InQue"} {
			label .queuser.status.v -width 15 -relief sunken -text $questatus($what)
		} else {
			if {$mp3tool(client) == "epic ircII"} {
				label .queuser.status.v -width 15 -relief sunken -text $questatus($what)
			} else {
				label .queuser.status.v -width 20 -relief sunken -text $questatus($what)
			}
		}
		label .queuser.time.l -bg "light blue" -text [Trans last_change]
		label .queuser.time.v -width 20 -relief sunken -text [clock format $questart($what) -format "%T"]
		label .queuser.file.l -bg "light blue" -text [Trans file]
		label .queuser.file.v -relief sunken -text $quefile($what)
		button .queuser.name.msg -image send -command "MsgQue $what"
		button .queuser.time.play -image sm_play -command "PlaySelected [HasServerFile $quefile($what)]"
		if {$questatus($what) == "InQue"} {
			button .queuser.status.dump -image dump -command "KillQue $what"
		} else {
			if {$mp3tool(client) == "epic ircII"} {
				button .queuser.status.dump -image dump -command "KillLiveQue $what"
			}
		}
		pack .queuser.name -fill both -expand y
		pack .queuser.status -fill both -expand y
		pack .queuser.time -fill both -expand y
		pack .queuser.file -fill both -expand y
		pack .queuser.time.play -side right
		pack .queuser.name.msg -side right
		if {$questatus($what) == "InQue"} {
			pack .queuser.status.dump -side right
		} else {
			if {$mp3tool(client) == "epic ircII"} {
				pack .queuser.status.dump -side right
			}
		}
		pack .queuser.name.l .queuser.name.v -side left -expand y -fill both
		pack .queuser.status.l .queuser.status.v -side left -expand y -fill both
		pack .queuser.time.l .queuser.time.v -side left -expand y -fill both
		pack .queuser.file.l .queuser.file.v -side left -expand y -fill both
		wm resizable .queuser 0 0
	} else {
		destroy .queuser
		update
		QueButton $what
		return
	}
}

proc StopQue { what } {
	if { [winfo exists .queuser] == 1} {destroy .queuser}
}

proc SendUser {what who} {
        global queuser

	SendMSG $queuser($who) [subst $what]
        if [winfo exists .msg] {
                destroy .msg
        }
}

proc MsgQue { what } {
	global queuser

        if ![winfo exists .msg] {
                toplevel .msg
                wm title .msg "MP3Tool [Trans by] Cruise - [Trans sending_to] $queuser($what)"
                entry .msg.what -width 50 -relief sunken
                button .msg.send -text [Trans send]  -bg "light blue" \
                        -activeforeground red \
                        -activebackground "light blue" \
                        -command "SendUser \[.msg.what get\] $what"
                pack .msg.send -side left
                pack .msg.what -side right -fill both -expand y
                bind .msg <Return> "SendUser \[.msg.what get\] $what"
        } else {
                destroy .msg
                update
                MsgQue $what
                return
        }
	if { [winfo exists .queuser] == 1} {destroy .queuser}
}

proc Find_File {who what} {
	global totfin sendlist sends mp3tool total_files
	global findtimer

	if {!$sends(FIND)} {return}
	set this ""
	set found 0
	set finds 0
	set tfincr 0
	set nick $mp3tool(nick)

	set what [string trim $what]
	set fixedwho [nick_fix $who]
	for {set c 0} {$c < [string length $what]} {incr c} {
		if {[string range $what $c $c] == "-"} {
			append this " "
		} else {
			switch -exact [string range $what $c $c] {
				"*"	{append this " "}
				"?"	{append this " "}
				"_"	{append this " "}
				default {append this [string range $what $c $c]}
			}
		}
	}
	if {[info exists findtimer($who)]} {
		set aftr $findtimer($who)
	} else {
		set aftr 0
		set findtimer($who) 0
	}
	for {set c 0} {$c < $mp3tool(totalfiles)} {incr c} {
		set all 1
		foreach word $this {
			if {[string first $word [string tolower $sendlist($c)] ] == -1} {
				set all 0
			}
		}
		if {$all == 1} {
			if {!$tfincr} {
				incr totfin
				if {$mp3tool(client) == "BitchX" || $mp3tool(client) == "mIRC" || $mp3tool(client) == "epic ircII"} {
					.status configure -text "[Trans finds] $totfin -- [Trans lists] $mp3tool(total_lists) -- [Trans sent] $total_files"
				}
				set tfincr 1
			}
			if {$finds >= $sends(MAX_FIND)} {
				if {$sends(COLOR)} {
					after $aftr "SendMSG $fixedwho \"\0031,1\0033[Trans your_search_returned_more_than] \00304$sends(MAX_FIND) \0033[Trans files_please_download_my_list_by_typing] \0038@$nick \0033[Trans or_refine_your_search]\""
				} else {
					after $aftr "SendMSG $fixedwho \"[Trans your_search_returned_more_than] $sends(MAX_FIND) [Trans files_please_download_my_list_by_typing] @$nick [Trans or_refine_your_search]\""
				}
				incr findtimer($who) 2000
				incr aftr 2000
				return
			}
			if {!$found} {
				if {$sends(COLOR)} {
					after $aftr "SendMSG $fixedwho \"\0031,1\0033[Trans here_are_the_matches_to_your] \0038@find \0033[Trans request_to_get_any_file_just_cut_and_paste_the_lines_into_the_channel].\""
				} else {
					after $aftr "SendMSG $fixedwho \"[Trans here_are_the_matches_to_your] @find [Trans request_to_get_any_file_just_cut_and_paste_the_lines_into_the_channel].\""
				}
				incr findtimer($who) 2000
				incr aftr 2000
				set found 1
			}
			set f [nick_fix $sendlist($c)]
			if {$sends(COLOR)} {
				after $aftr "SendMSG $fixedwho \"\0031,1\00310!$nick $f\""
			} else {
				after $aftr "SendMSG $fixedwho \"!$nick $f\""
			}
			incr findtimer($who) 2000
			incr aftr 2000
			incr finds
		}
	}
	after $aftr "set findtimer($fixedwho) 5000"
}

proc CTCP_Find_File {who what} {
	global totfin sendlist sends mp3tool total_files

	if {!$sends(FIND)} {return}
	if {!$sends(CTCP)} {return}
	set this ""
	set found 0
	set finds 0
	set tfincr 0
	set nick $mp3tool(nick)

	set what [string trim $what]
	for {set c 0} {$c < [string length $what]} {incr c} {
		if {[string range $what $c $c] == "-"} {
			append this " "
		} else {
			switch -exact [string range $what $c $c] {
				"*"	{append this " "}
				"?"	{append this " "}
				"_"	{append this " "}
				default {append this [string range $what $c $c]}
			}
		}
	}
	for {set c 0} {$c < $mp3tool(totalfiles)} {incr c} {
		set all 1
		foreach word $this {
			if {[string first $word [string tolower $sendlist($c)] ] == -1} {
				set all 0
			}
		}
		if {$all == 1} {
			if {!$tfincr} {
				incr totfin
				if {$mp3tool(client) == "BitchX" || $mp3tool(client) == "mIRC" || $mp3tool(client) == "epic ircII"} {
					.status configure -text "[Trans finds] $totfin -- [Trans lists] $mp3tool(total_lists) -- [Trans sent] $total_files"
				}
				set tfincr 1
			}
			if {$finds >= $sends(MAX_FIND)} {
				return
			}
			if {!$found} {
				set found 1
			}
			SendCTCP $who $sendlist($c) MP3
			incr finds
		}
	}
}

proc KillQue {who} {
	global quefile queuser sends

	if {$sends(COLOR)} {
		SendMSG $queuser($who) "\0031,1\0034$quefile($who) \0033[Trans has_been_removed_from_my_que_sorry]."
	} else {
		SendMSG $queuser($who) "$quefile($who) [Trans has_been_removed_from_my_que_sorry]."
	}
	ShuffleQue $who
	if [winfo exists .queuser] {destroy .queuser}
}

proc KillLiveQue {who} {
	global quefile queuser
	CancelDCC $queuser($who) $quefile($who)
	if [winfo exists .queuser] {destroy .queuser}
}

proc SendQue {what} {
	global queuser quecount

	for {set c 0} {$c < $quecount} {incr c} {
		SendMSG $queuser($c) [subst $what]
	}
	if [winfo exists .send] {destroy .send}
}

proc SendToQue { } {
	global mp3tool tcl_platform

        if ![winfo exists .send] {
                toplevel .send
                wm title .send "MP3Tool [Trans by] Cruise - [Trans sending_to_que]"
		set platform [array get tcl_platform platform]
		if {$platform == "platform unix"} {
			wm iconbitmap .send @$mp3tool(dir)/images/send.xbm
		}
                entry .send.what -width 50 -relief sunken
                button .send.send -text [Trans send]  -bg "light blue" \
                        -activeforeground red \
                        -activebackground "light blue" \
                        -command { SendQue [.send.what get] }
                pack .send.send -side left
                pack .send.what -side right -fill both -expand y
                bind .send <Return> { SendQue [.send.what get] }
        } else {
                destroy .send
                update
                SendToQue
                return
        }
}

proc SelectedFile {file} {
	global serving mp3tool sends sendlist 
	global mp3tool total_files grand_total
	global totfin uservar quecount

	set nick $mp3tool(nick)
	set oldlast 0
	
	for {set c 0} {$c < $mp3tool(totalfiles)} {incr c} {
		if {[string first $sendlist($c) $file] >= 0} {
			set mp3tool(lastoffer) $c
			set oldlast 1
		}
	}
	if {!$oldlast} {return}

	if [winfo exists .server] {
		.server.top.entry delete 0 end
		.server.top.entry insert end [HasServerFile $sendlist($mp3tool(lastoffer))]
	}
	if [winfo exists .server] {
		.server.sep.find.l configure -text "$totfin [Trans finds]"
		.server.sep.lists.l configure -text "[Trans sent] $mp3tool(total_lists) [Trans lists]"
		.server.sep.files.l configure -text "[Trans sent] $total_files MP3s"
		.server.sep.grand.l configure -text "[Trans grandtotal] $grand_total MP3s"
		.server.que.max.files.m.b configure -text "$mp3tool(totalfiles) [Trans files]"
	}
}
