proc MP3Tool_endDCC {type index fail_type debug} {
	return 1
}

proc ToggleMP3Tool {} {
	global mp3tool MV
	if {$mp3tool(onoff)} {
		set mp3tool(onoff) 0
		StopMP3Tool
	} else {
		set mp3tool(onoff) 1
		$MV(plugin_frame).mp3tool flash
		GetWindowSetup
	}
}


proc DCCStatus {who file qn} {
	global MV mp3tool quefile

	set rc 3
	foreach idx $MV(dcc_list) {
		if {$MV(DCC.$idx.sender) == $who && [file tail $MV(DCC.$idx.file)] == $file} {
			set rc 1
			break
		}
	}
	if {$rc == 3} {
		if {[file exists "$mp3tool(dir)/tmp/$quefile($qn)"]} {
			set inusebyother 0
			for {set d 0} {$d < $mp3tool(quecount)} {incr d} {
				if {"$quefile($d)" == "$quefile($qn)" && $d != $qn} {
					set inusebyother 1
					break
				}
			}
			if {"$mp3tool(dir)/tmp/$quefile($qn)" != "$mp3tool(dir)/tmp/" && !$inusebyother} {
				catch {file delete "$mp3tool(dir)/tmp/$quefile($qn)"} error
			}
		}

	}
	return $rc
}


proc SendCTCP {channel file type} {
	global mp3tool
	switch -exact -- $type {
		"MP3" {SendToServer "SUB * MP3 $file"}
	}
}

proc SendFILE {who what} {
	global mp3tool

        DCCSend $who "$what"
}

proc SendMSG {channel message} {
	global mp3tool

	SendToServer "PRIVMSG $channel $message"
}

proc MP3Tool_ProcessInput {org cmd parms rest} {
	global mp3tool MV sends filelist
	global scrlk 

	if {!$mp3tool(onoff)} {return 1}
	if {$cmd == "PRIVMSG"} {set cmd "CHAT"}
	switch -exact -- $cmd {
		"SUB" {
			if $MV(debug) {DebugIt "(mp3tool) - Message On Sub Channel."}
			set parms [split $rest " "]
			set rest [string range $rest [expr [string first " " $rest] +1] end]
			if {[lindex $parms 1] == ""} {return 1}
			switch -exact -- [string tolower [lindex $parms 1]] {
				"mp3" {
					set user [lindex $parms 0]
					set file [string trim [string range $rest [expr [string first [string tolower $rest] "mp3"] +4] end]]
					set isfile [HasFile $file]
					if ![winfo exists .mp3] {
						GetWindowSetup
					}
					if {$isfile == "--"} {
						.mp3.l.list insert end "\[[clock format [clock seconds] -format "%T"]\] !$user $file"
					} else {
						.mp3.pl.entry delete 0 end
						.mp3.pl.entry insert end $isfile
					}
					while {$mp3tool(total) > $mp3tool(maxmp3s)} {
						.mp3.l.list delete 0
						incr mp3tool(total) -1
					}
					if { !$scrlk } {
						.mp3.l.list see end
					}
					return 0
				}
				"@find" {
					if $MV(debug) {DebugIt "(mp3tool) - Find Request"}
					if $mp3tool(serving) {
						set file [string range $rest [expr [string first " " $rest] +1] end]
						set file [string range $file [expr [string first " " $file] +1] end]
						CTCP_Find_File $lwho $file
					}
					return 0
				}
				"@ctcpfind" {
					if $MV(debug) {DebugIt "(mp3tool) - Find Request"}
					if $mp3tool(serving) {
						set file [string range $rest [expr [string first " " $rest] +1] end]
						set file [string range $file [expr [string first " " $file] +1] end]
						CTCP_Find_File $lwho $file
					}
					return 0
				}
			}
			return 1
		}
		"CHAT" {
			#
			# This is where many of our traps will be.
			# there needs to be some special configurations
			# to display or not display these commands. We tie
			# into the ProcessInput pre for this reason.
			#
			set lwho [string range $rest 0 [expr [string first " " $rest] -1]]
			set lrest [string range $rest [expr [string first " " $rest] +1] end]
			set lcmd [string range $lrest 0 [expr [string first " " $lrest] -1]]
			set lrest [string range $lrest [expr [string first " " $lrest] +1] end]
			set lparms [split $lrest " "]
			if {$lcmd == ""} {set lcmd $lrest}
			set lnick [string tolower $MV(nick)]
			set lcmd [string tolower $lcmd]
			set cmd1 "!$lnick"
			if $MV(debug) {DebugIt "CHAT -- $lcmd | $lwho | $lnick | $lrest | $cmd1 |"}
			if {$lcmd == "!$lnick"} {
				if $MV(debug) {DebugIt "(mp3tool) - FileRequest Received $rest"}
				set file [string range $rest [expr [string first " " $rest] +1] end]
				set file [string range $file [expr [string first " " $file] +1] end]
				if {$mp3tool(serving)} {
					QueRequest "[string trim $file]" $lwho
				}
				return 0
			}
			if {$lcmd == "@$lnick"} {
				if $MV(debug) {DebugIt "(mp3tool) - FileList Request"}
				if {$sends(LIST) && $mp3tool(serving)} {
					incr mp3tool(total_lists)
					DCCSend $lwho $filelist
				}
				return 0
			}
			if {$lcmd == "@find"} {
				if $MV(debug) {DebugIt "(mp3tool) - Find Request"}
				if $mp3tool(serving) {
					set file [string range $rest [expr [string first " " $rest] +1] end]
					set file [string range $file [expr [string first " " $file] +1] end]
					CTCP_Find_File $lwho $file
				}
				return 0
			}
			if {$lcmd == "@ctcpfind"} {
				if $MV(debug) {DebugIt "(mp3tool) - Find Request"}
				if $mp3tool(serving) {
					set file [string range $rest [expr [string first " " $rest] +1] end]
					set file [string range $file [expr [string first " " $file] +1] end]
					CTCP_Find_File $lwho $file
				}
				return 0
			}
			if {$lcmd == "@$lnick-remove"} {
				if $MV(debug) {DebugIt "(mp3tool) - Find Request"}
				return 0
			}
			if {$lcmd == "@$lnick-que"} {
				if $MV(debug) {DebugIt "(mp3tool) - ListQue"}
				que_report $lwho
				return 0
			}
		}
	}
	return 1
}

proc MP3Tool_ChangeNick {newnick} {
	global mp3tool

	if {$mp3tool(nick) != $newnick} {
		set mp3tool(nick) $newnick
		if $mp3tool(serving) {
			CreateListQuestion 1
		}
	}
	return 1
}

proc MP3Tool_ProcURL {who what type} {
	global MV

	switch -- [string tolower $type] {
		"file" {
			# Autogetting File!
			# Put a note in the text chat window.
			set parms [split $what "/"]
			set hp [split [lindex $parms 2] ":"]
			set fs [split [lindex $parms 3] ":"]
			if {[file extension [string tolower [lindex $fs 0]]] != ".mp3" && \
				[file extension [string tolower [lindex $fs 0]]] != ".txt"} {return 1}
			DCCGet [lindex $hp 0] [lindex $hp 1] [lindex $fs 0] [lindex $fs 1] DOWNLOAD $who
			if [winfo exists .chat] {
				.chat.chat.text insert end "***SYSTEM*** Downloading [lindex $fs 0] from $who ([lindex $fs 1] bytes)\n"
				if !$MV(textwindow.lock) {.chat.chat.text see end}
			}
			lappend MV(chats) "***SYSTEM*** Downloading [lindex $fs 0] from $who ([lindex $fs 1] bytes)\n"
			if {[llength $MV(chats)] > $MV(chatsave)} {
				set MV(chats) [lreplace $MV(chats) 0 0]
			}
			return 0
		}
	}
	return 1
}
