# OpenVerse MP3Tool Plugin
# 
# This is the plugin initialization file for MP3Tool.
# It will setup all things nessecary for MP3tool to run
# and operate with OpenVerse.
#
# Module Name		- MP3Tool Plugin
# Current Maintainter 	- Cruise <cruise@drunkenbastards.org>
# Sourced By		- OpenVerse Plugin routine
#
# Copyright (C) 1999 David Gale <cruise@drunkenbastards.org>
# For more information visit http://daytona.com/mp3tool/
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
# USA.

# Register with the OpenVerse functions we will be using.

RegisterPlugin MP3Tool ProcessInput.pre MP3Tool_ProcessInput
RegisterPlugin MP3Tool ChangeNick MP3Tool_ChangeNick
RegisterPlugin MP3Tool ProcURL MP3Tool_ProcURL
RegisterPlugin MP3Tool endDCC MP3Tool_endDCC

global mp3tool

global mp3dirs
global sends sendlist filelist
global serverdirs
global total_files grand_total grand_date recentcount
global scrlk recent quebutton questatus queuser
global quefile questart totfin quepercent
global slotname slotsend slotexp zquepercent zcps connections
global slotsavail slottime slotque slotqavail slotcps slotfiles


set mp3tool(homedir) "$MV(homedir)/plugins/MP3Tool"
set mp3tool(dir) "$MV(homedir)/plugins/MP3Tool"


#--------------------------
# Fix us!!!!!!!
#--------------------------
set zcps(KJGLJGLJHTVKJHTTJKEVKDJTKJTXDJHVJHTVKHTDKJDTVJHVKDJT) 0
set mp3tool(grand_file) "GrandTotals.txt"
set mp3tool(total_lists) 0
set total_files 0
set mp3tool(serving) 0
set recentcount 0
set mp3tool(quecount) 0
set mp3tool(chlst) 1
set connections 1
set sendlist(0) "nothing"
#--------------------------

source "$mp3tool(homedir)/func2.tcl"
source "$mp3tool(homedir)/server.tcl"
source "$mp3tool(homedir)/configure.tcl"
source "$mp3tool(homedir)/files.tcl"
source "$mp3tool(homedir)/OVMP3Tool.tcl"

set mp3tool(client) "OpenVerse"
set mp3tool(nick) $MV(nick)
set mp3tool(totalcps) 0
set mp3tool(offleft) 0
set mp3tool(offright) 0
set mp3tool(configfile) "$mp3tool(homedir)/MP3Tool.cfg"
set mp3tool(chan) "OpenVerse"
set mp3tool(distribute) 0
set mp3tool(totalslots) 0
set mp3tool(totalfiles) -1
set mp3tool(lastoffer) 0

## Initalize some stuff.
SetGrandTotal
SetVars

## Almost done!
set mp3tool(advertisement) " -- MP3Tool for OpenVerse $mp3tool(version) http://openverse.org/plugins/"
set mp3tool(color_advertisement) " \00304-- \0038(\00313M\0033P3\0038T\00313o\0033o\00310l\0038) \0033for \00310 OpenVerse \0034v$mp3tool(version) \00304http://openverse.org/plugins/"

#---------------------------------------------------------------------------
#               M E T A V E R S E    Setup
#---------------------------------------------------------------------------

#----------------------------------
# Color config for OpenVerse button.
#----------------------------------
set mp3tool(color.buttons.fg) "black"
set mp3tool(color.buttons.afg) "red"
set mp3tool(color.buttons.bg)  "light blue"
set mp3tool(color.buttons.abg) "red"
set mp3tool(onoff) 0

#------------------------------
# Make our presence known!
#------------------------------
# Need a new smaller image.
image create photo MP3Tool -file "$mp3tool(dir)/images/OVtool.gif"

checkbutton $MV(plugin_frame).mp3tool -image MP3Tool \
	-variable $mp3tool(onoff) -relief raised \
	-command {ToggleMP3Tool} \
	-onvalue 1 -offvalue 0

if {!$MV(use_windowmanager_colors)} {
	$MV(plugin_frame).mp3tool configure \
		-fg $mp3tool(color.buttons.fg) \
		-activeforeground $mp3tool(color.buttons.afg) \
		-bg $mp3tool(color.buttons.bg) \
		-activebackground $mp3tool(color.buttons.abg)
}

pack $MV(plugin_frame).mp3tool -side left -fill y

set mp3tool(chan) "*"
if $MV(debug) {LogIt "(MP3Tool) - Initialization complete!"}
#-------------------------------
# And ttttthats all folks!
#-------------------------------
