
proc DrawStyle {what} {
        global mp3tool sends lastoffer sendlist
        global mp3tool total_lists total_files grand_total quepercent
        global totfin uservar quecount queuser questatus
        global questart Csends

	set nick $mp3tool(nick)
	set Csends(STYLE) $what
	.configure.style.text.text configure -state normal
	.configure.style.text.text delete 0.0 end
	source $mp3tool(dir)/styles/Default
	catch {source $mp3tool(dir)/styles/$what} error
	for {set c 1} {$c <= $nocolor(lines)} {incr c} {
		.configure.style.text.text insert end "$nocolor($c)\n"
	}
	.configure.style.text.text configure -state disabled
	
}



proc DrawConfigureWindow { } {
	global sends currentNet Csends mp3tool Cmp3tool
	global tcl_platform Cserverdirs serverdirs Cmp3dirs mp3dirs
	global uservar Cuservar filelist grand_date SS_State
	global Cgrand_date Cfilelist SD_State MS_State

	if ![winfo exists .configure] {
		set SD_State 0
		set MS_State 0
		set SS_State 0
		set nick $mp3tool(nick)
		set platform [array get tcl_platform platform]
		set Csends(CTCP) $sends(CTCP)
		set Csends(CHAN) $sends(CHAN)
		set Csends(FIND) $sends(FIND)
		set Csends(COLOR) $sends(COLOR)
		set Csends(LIST) $sends(LIST)
		set Csends(STYLE) $sends(STYLE)
		set Csends(MAX_FIND) $sends(MAX_FIND)
		set Cmp3tool(quemax) $mp3tool(quemax)
		set Cmp3tool(freq) $mp3tool(freq)
		set Cmp3tool(sendmax) $mp3tool(sendmax)
		set Cmp3tool(MAXINQUE) $mp3tool(MAXINQUE)
		set Cmp3tool(MAXINSEND) $mp3tool(MAXINSEND)
		set Cmp3tool(maxmp3s) $mp3tool(maxmp3s)
		set Cmp3tool(maxrecent) $mp3tool(maxrecent)
		set Cmp3tool(language) $mp3tool(language)
		set Cmp3tool(lineup) $mp3tool(lineup)
		set Cmp3tool(autoplay) $mp3tool(autoplay)
		set Cmp3tool(debugger) $mp3tool(debugger)
		set Cserverdirs $serverdirs
		set Cmp3dirs $mp3dirs
		set Cmp3tool(distribute) $mp3tool(distribute)
		set Cfilelist $filelist
		set Cmp3tool(grand_file) $mp3tool(grand_file)
		set Cgrand_date $grand_date
		set Cmp3tool(x11amp) $mp3tool(x11amp)

		for {set c 0} {$c <= 20} {incr c} {
			set Cuservar($c) $uservar($c)
		}
		toplevel .configure
		wm title .configure "MP3Tool [Trans by] Cruise - [Trans mp3tool_configurator]"
		if {$platform == "platform unix"} {
			wm iconbitmap .configure @$mp3tool(dir)/images/configure.xbm
		}
		frame .configure.redline
		label .configure.redline.l -bg red -fg red -relief raised \
			-borderwidth 2
		

		frame .configure.sends
		frame .configure.num 
		frame .configure.cli

		frame .configure.num.slot -relief raised -bg "light blue"
		frame .configure.num.que -relief raised -bg "light blue"
		frame .configure.num.freq -relief raised -bg "light blue"
		frame .configure.num.find -relief raised -bg "light blue"
		frame .configure.num.quem -relief raised -bg "light blue"
		frame .configure.num.ques -relief raised -bg "light blue"

		
		frame .configure.sends.ctcp -relief raised -bg "light blue"
		frame .configure.sends.msg -relief raised -bg "light blue"
		frame .configure.sends.color -relief raised -bg "light blue"
		frame .configure.sends.find -relief raised -bg "light blue"
		frame .configure.sends.list -relief raised -bg "light blue"
		frame .configure.sends.auto -relief raised -bg "light blue"

		scale .configure.num.freq.e -bg "light blue" -orient horizontal -from 0 -to 30 \
			-variable Cmp3tool(freq) -label [Trans send_frequency] -relief raised \
			-borderwidth 2
		scale .configure.num.slot.e -bg "light blue" -orient horizontal -from 0 -to $Cmp3tool(quemax) \
			-variable Cmp3tool(sendmax) -label [Trans send_slots] -relief raised \
			-borderwidth 2
		scale .configure.num.que.e -bg "light blue" -orient horizontal -from 0 -to 30 \
			-variable Cmp3tool(quemax) -label [Trans que_slots] -relief raised \
			-borderwidth 2 -command CResetSendSlots

		scale .configure.num.quem.e -bg "light blue" -orient horizontal -from 1 -to 30 \
			-variable Cmp3tool(MAXINQUE) -label [Trans max_inque] -relief raised \
			-borderwidth 2

		scale .configure.num.ques.e -bg "light blue" -orient horizontal -from 1 -to 30 \
			-variable Cmp3tool(MAXINSEND) -label [Trans max_sending] -relief raised \
			-borderwidth 2

		scale .configure.num.find.e -bg "light blue" -orient horizontal -from 0 -to 100 \
			-variable Csends(MAX_FIND) -label [Trans max_find] -relief raised \
			-borderwidth 2


		scale .configure.cli.offer -bg "light blue" -orient horizontal -from 0 -to 500 \
			-variable Cmp3tool(maxmp3s) -label [Trans offer_max] -relief raised \
			-borderwidth 2
		
		frame .configure.cli.s
		button .configure.cli.s.style -activebackground "light blue" -activeforeground "red" -bg "light blue"  -text [Trans configure_send_style] -command ConfigureSendStyle
		button .configure.cli.s.misc -activebackground "light blue" -activeforeground "red" -bg "light blue"  -text [Trans configure_misc_settings] -command ConfigureMiscSettings
		button .configure.cli.s.dirs -activebackground "light blue" -activeforeground "red" -bg "light blue"  -text [Trans configure_server_dirs] -command ConfigureServerDirs

		scale .configure.cli.recycle -bg "light blue" -orient horizontal -from 0 -to 500 \
			-variable Cmp3tool(maxrecent) -label [Trans max_recycle] -relief raised \
			-borderwidth 2

		label .configure.sends.l -text [Trans channel_send_controls] \
			-bg "blue" -relief raised -fg "white"
		label .configure.sends.ctcp.txt -text [Trans ctcp] \
                        -bg "light blue"
                checkbutton .configure.sends.ctcp.but -variable Csends(CTCP) \
                        -offvalue 0 -bg "light blue"
		label .configure.sends.auto.txt -text [Trans auto_play] \
                        -bg "light blue"
                checkbutton .configure.sends.auto.but -variable Cmp3tool(autoplay) \
                        -offvalue 0 -bg "light blue"
                label .configure.sends.msg.txt -text [Trans channel] \
                        -bg "light blue"
                checkbutton .configure.sends.msg.but -variable Csends(CHAN) \
                        -offvalue 0 -bg "light blue"
                label .configure.sends.color.txt -text [Trans colorize] \
                        -bg "light blue"
                checkbutton .configure.sends.color.but -variable Csends(COLOR) \
                        -offvalue 0 -bg "light blue"
                label .configure.sends.find.txt -text [Trans @find] \
                        -bg "light blue"
                checkbutton .configure.sends.find.but -variable Csends(FIND) \
                        -offvalue 0 -bg "light blue"
                label .configure.sends.list.txt -text "@$nick" \
                        -bg "light blue"
                checkbutton .configure.sends.list.but -variable Csends(LIST) \
                        -offvalue 0 -bg "light blue"

		frame .configure.buttons -relief sunken -borderwidth 2
		button .configure.buttons.a -text [Trans cancel] -command {destroy .configure} -activeforeground red -bg "light blue" -activebackground "light blue"
		button .configure.buttons.b -text [Trans save_and_apply] -command {SaveConfig 1} -activeforeground red -bg "light blue" -activebackground "light blue"
		button .configure.buttons.c -text [Trans apply_only] -command {SaveConfig 2} -activeforeground red -bg "light blue" -activebackground "light blue"
		button .configure.buttons.d -text [Trans save_only] -command {SaveConfig 3} -activeforeground red -bg "light blue" -activebackground "light blue"
		button .configure.buttons.e -text [Trans re_load_running_config] -command {destroy .configure;DrawConfigureWindow} -activeforeground red -bg "light blue" -activebackground "light blue"

		pack .configure.sends -fill both -expand y
		pack .configure.num -fill both -expand y
		pack .configure.cli -fill both -expand y

		pack .configure.sends.l -side top -fill both -expand y
		pack .configure.sends.auto .configure.sends.ctcp .configure.sends.msg .configure.sends.color .configure.sends.find .configure.sends.list -side left -fill both -expand y
		pack .configure.num.slot .configure.num.freq .configure.num.que .configure.num.ques .configure.num.quem .configure.num.find -side left -fill both -expand y

		pack .configure.sends.auto.but .configure.sends.auto.txt -side left
		pack .configure.sends.ctcp.but .configure.sends.ctcp.txt -side left
		pack .configure.sends.msg.but .configure.sends.msg.txt -side left
		pack .configure.sends.color.but .configure.sends.color.txt -side left
		pack .configure.sends.find.but .configure.sends.find.txt -side left
		pack .configure.sends.list.but .configure.sends.list.txt -side left

		pack .configure.num.quem.e .configure.num.ques.e .configure.num.find.e .configure.num.freq.e .configure.num.que.e .configure.num.slot.e -side left -fill both -expand y


		pack .configure.cli.offer .configure.cli.s .configure.cli.recycle -side left -fill both -expand y
		pack .configure.cli.s.style .configure.cli.s.misc .configure.cli.s.dirs -side top -fill both -expand y

		pack .configure.redline -fill both -expand y
		pack .configure.redline.l -fill both -expand y


		pack .configure.buttons -fill both -expand y
		pack .configure.buttons.a .configure.buttons.b .configure.buttons.c .configure.buttons.d .configure.buttons.e -side left -fill both -expand y
		wm resizable .configure 0 0
	}
}

proc CAddServDirectory {} {
	global mp3tool
	set mp3tool(recurse_flag) 0

	if [winfo exists .diroption] {
		destroy .diroption
	}
	toplevel .diroption
	wm title .diroption "MP3Tool [Trans directory_addition]"
	checkbutton .diroption.rec -text [Trans recurse] -variable mp3tool(recurse_flag) \
		-relief raised -borderwidth 2
	button .diroption.del -text [Trans add_directory] -activeforeground red -command "AddDir serverdirs \[.diroption.ent get\]"
	entry .diroption.ent
	pack .diroption.rec .diroption.del .diroption.ent -side left -fill both -expand y
}

proc CAddMP3Directory {} {
	global mp3tool
	set mp3tool(recurse_flag) 0

	if [winfo exists .diroption] {
		destroy .diroption
	}
	toplevel .diroption
	wm title .diroption "MP3Tool [Trans directory_addition]"
	checkbutton .diroption.rec -text [Trans recurse] -variable mp3tool(recurse_flag) \
		-relief raised -borderwidth 2
	button .diroption.del -text [Trans add_directory] -activeforeground red -command "AddDir mp3dirs \[.diroption.ent get\]"
	entry .diroption.ent
	pack .diroption.rec .diroption.del .diroption.ent -side left -fill both -expand y
}

proc Recurse {dir which} {
	global mp3tool Cserverdirs Cmp3dirs

	foreach ddir [glob -nocomplain $dir/*] {
		if [file isdirectory $ddir] {
			switch -exact $which {
				serverdirs	{
					lappend Cserverdirs $ddir
				}
				mp3dirs	{
					lappend Cmp3dirs $ddir
				}
			}
		}
		Recurse $ddir $which
	}
}


proc AddDir {which what} {
	global Cserverdirs Cmp3dirs mp3tool
	
	destroy .diroption	
	if ![file isdirectory $what] {
                if [winfo exists .error] {destroy .error}
                toplevel .error
                wm title .error "MP3Tool [Trans by] Cruise - [Trans error]!!"
		ErrorIcon .error
                label .error.l -text [Trans directory_does_not_exist]
                label .error.ll -text [Trans please_check_and_try_again]
                button .error.b -text [Trans ok] -command {destroy .error}
                pack .error.l
                pack .error.ll
                pack .error.b
                return
	} {
		if {$mp3tool(recurse_flag)} {
			Recurse $what $which
		}
		switch -exact $which {
			serverdirs	{
				lappend Cserverdirs $what
			}
			mp3dirs	{
				lappend Cmp3dirs $what
			}
		}
	}
	.configure.f.br.list delete 0 end
	.configure.f.bl.list delete 0 end
	foreach dir $Cserverdirs {
		.configure.f.br.list insert end $dir
	}
	foreach dir $Cmp3dirs {
		.configure.f.bl.list insert end $dir
	}
}

proc DirOptions {which what} {
	if [winfo exists .diroption] {
		destroy .diroption
	}
	toplevel .diroption
	wm title .diroption "MP3Tool [Trans directory_selection]"
	button .diroption.del -text [Trans delete_directory] -activeforeground red -command "DeleteDir $which \"$what\""
	pack .diroption.del -fill both -expand y
}

proc DeleteDir {which what} {
	global Cserverdirs Cmp3dirs
	switch -exact $which {
		serverdirs	{
			set idx [lsearch -exact $Cserverdirs $what]
			set Cserverdirs [lreplace $Cserverdirs $idx $idx]
		}
		mp3dirs	{
			set idx [lsearch -exact $Cmp3dirs $what]
			set Cmp3dirs [lreplace $Cmp3dirs $idx $idx]
		}
	}
	.configure.f.br.list delete 0 end
	.configure.f.bl.list delete 0 end
	foreach dir $Cserverdirs {
		.configure.f.br.list insert end $dir
	}
	foreach dir $Cmp3dirs {
		.configure.f.bl.list insert end $dir
	}
	destroy .diroption	
}

proc CResetSendSlots {what} {
	.configure.num.slot.e configure -to $what
}

proc SaveConfig {how} {
	global sends currentNet Csends mp3tool Cmp3tool
	global tcl_platform Cserverdirs serverdirs Cmp3dirs mp3dirs
	global uservar Cuservar filelist grand_date
	global Cgrand_date Cfilelist INTwords

	set platform [array get tcl_platform platform]

	if {$mp3tool(language) != $Cmp3tool(language)} {set lang_flag 1} {set lang_flag 0}

	switch $how {
		1	{
			# Save and Apply
			set outfile [open $mp3tool(configfile) w]
			puts $outfile "set sends(CTCP) $Csends(CTCP)"
			puts $outfile "set sends(CHAN) $Csends(CHAN)"
			puts $outfile "set sends(FIND) $Csends(FIND)"
			puts $outfile "set sends(COLOR) $Csends(COLOR)"
			puts $outfile "set sends(LIST) $Csends(LIST)"
			puts $outfile "set sends(MAX_FIND) $Csends(MAX_FIND)"
			puts $outfile "set sends(STYLE) \"$Csends(STYLE)\""
			puts $outfile "set mp3tool(MAXINSEND) $Cmp3tool(MAXINSEND)"
			puts $outfile "set mp3tool(MAXINQUE) $Cmp3tool(MAXINQUE)"
			puts $outfile "set mp3tool(quemax) $Cmp3tool(quemax)"
			puts $outfile "set mp3tool(sendmax) $Cmp3tool(sendmax)"
			puts $outfile "set mp3tool(maxmp3s) $Cmp3tool(maxmp3s)"
			puts $outfile "set mp3tool(maxrecent) $Cmp3tool(maxrecent)"
			puts $outfile "set mp3tool(language) $Cmp3tool(language)"
			puts $outfile "set mp3tool(freq) $Cmp3tool(freq)"
			puts $outfile "set mp3tool(autoplay) $Cmp3tool(autoplay)"
			puts $outfile "set mp3tool(debugger) $Cmp3tool(debugger)"
			if [winfo exists .configure.info] {
				puts $outfile "set mp3tool(lineup) \"[.configure.info.c.e get]\""
				puts $outfile "set mp3tool(x11amp) \"[.configure.info.x.e get]\""
				puts $outfile "set filelist \"[.configure.info.l.e get]\""
				puts $outfile "set mp3tool(grand_file) \"[.configure.info.r.e get]\""
			} else {
				puts $outfile "set mp3tool(lineup) \"$Cmp3tool(lineup)\""
				puts $outfile "set mp3tool(x11amp) \"$Cmp3tool(x11amp)\""
				puts $outfile "set filelist \"$Cfilelist\""
				puts $outfile "set mp3tool(grand_file) \"$Cmp3tool(grand_file)\""
			}
			puts $outfile "set grand_date \"$Cgrand_date\""
			puts $outfile "set mp3dirs \{ $Cmp3dirs \}"
			puts $outfile "set serverdirs \{ $Cserverdirs \}"
			puts $outfile "set mp3tool(distribute) $Cmp3tool(distribute)"
			for {set c 0} {$c <= 20} {incr c} {
				puts $outfile "set uservar($c) \"$uservar($c)\""
			}
			close $outfile
			if {$mp3tool(autoplay) != $Cmp3tool(autoplay)} {
				ToggleAutoPlay
			}
			set sends(CTCP) $Csends(CTCP)
			set sends(CHAN) $Csends(CHAN) 
			set sends(FIND) $Csends(FIND)
			set sends(COLOR) $Csends(COLOR)
			set sends(LIST) $Csends(LIST)
			set sends(STYLE) $Csends(STYLE)
			set sends(MAX_FIND) $Csends(MAX_FIND)
			set mp3tool(quemax) $Cmp3tool(quemax)
			set mp3tool(freq) $Cmp3tool(freq)
			set mp3tool(autoplay) $Cmp3tool(autoplay)
			set mp3tool(debugger) $Cmp3tool(debugger)
			set mp3tool(sendmax) $Cmp3tool(sendmax)
			set mp3tool(MAXINQUE) $Cmp3tool(MAXINQUE)
			set mp3tool(MAXINSEND) $Cmp3tool(MAXINSEND)
			set mp3tool(maxmp3s) $Cmp3tool(maxmp3s)
			set mp3tool(maxrecent) $Cmp3tool(maxrecent)
			set mp3tool(language) $Cmp3tool(language)
			set serverdirs $Cserverdirs
			set mp3dirs $Cmp3dirs
			set mp3tool(distribute) $Cmp3tool(distribute)
			if [winfo exists .configure.info] {
				set mp3tool(lineup) [.configure.info.c.e get]
				set filelist [.configure.info.l.e get]
				set mp3tool(grand_file) [.configure.info.r.e get]
				set mp3tool(x11amp) [.configure.info.x.e get]
			} else {
				set mp3tool(lineup) $Cmp3tool(lineup)
				set filelist $Cfilelist
				set mp3tool(grand_file) $Cmp3tool(grand_file)
				set mp3tool(x11amp) $Cmp3tool(x11amp)
			}	
			set grand_date $Cgrand_date
			for {set c 0} {$c <= 20} {incr c} {
				set uservar($c) $Cuservar($c)
			}
			if {$lang_flag} {
				source $mp3tool(dir)/languages/$mp3tool(language)
				update
				if [winfo exists .mp3] {
					destroy .mp3
					GetWindowSetup
				}
				if [winfo exists .help] {
					destroy .help
					MP3ToolHelp
				}
				if [winfo exists .select] {destroy .select}
				if [winfo exists .send] {destroy .send}
				if [winfo exists .recycle] {destroy .recycle}
				if [winfo exists .slots] {destroy .slots}
				if [winfo exists .olmp3] {destroy .olmp3}
				if [winfo exists .create] {destroy .create}
				if [winfo exists .lmp3] {destroy .lmp3}
				if [winfo exists .server] {
					destroy .server
					DrawServerWindow
				}
				if [winfo exists .setupque] {destroy .setupque}
				if [winfo exists .setspecial] {destroy .setspecial}
				if [winfo exists .queuser] {destroy .queuser}
				if [winfo exists .msg] {destroy .msg}
			}	
		}
		2	{
			# Apply Only
			if {$mp3tool(autoplay) != $Cmp3tool(autoplay)} {
				ToggleAutoPlay
			}
			set sends(CTCP) $Csends(CTCP)
			set sends(CHAN) $Csends(CHAN) 
			set sends(FIND) $Csends(FIND)
			set sends(COLOR) $Csends(COLOR)
			set sends(LIST) $Csends(LIST)
			set sends(STYLE) $Csends(STYLE)
			set sends(MAX_FIND) $Csends(MAX_FIND)
			set mp3tool(quemax) $Cmp3tool(quemax)
			set mp3tool(freq) $Cmp3tool(freq)
			set mp3tool(autoplay) $Cmp3tool(autoplay)
			set mp3tool(debugger) $Cmp3tool(debugger)
			set mp3tool(sendmax) $Cmp3tool(sendmax)
			set mp3tool(MAXINQUE) $Cmp3tool(MAXINQUE)
			set mp3tool(MAXINSEND) $Cmp3tool(MAXINSEND)
			set mp3tool(maxmp3s) $Cmp3tool(maxmp3s)
			set mp3tool(maxrecent) $Cmp3tool(maxrecent)
			set mp3tool(language) $Cmp3tool(language)
			if [winfo exists .configure.info] {
				set mp3tool(lineup) [.configure.info.c.e get]
				set filelist [.configure.info.l.e get]
				set mp3tool(grand_file) [.configure.info.r.e get]
				set mp3tool(x11amp) [.configure.info.x.e get]
			} else {
				set mp3tool(lineup) $Cmp3tool(lineup)
				set filelist $Cfilelist
				set mp3tool(grand_file) $Cmp3tool(grand_file)
				set mp3tool(x11amp) $Cmp3tool(x11amp)
			}	
			set serverdirs $Cserverdirs
			set mp3dirs $Cmp3dirs
			set mp3tool(distribute) $Cmp3tool(distribute)
			set grand_date $Cgrand_date
			for {set c 0} {$c <= 20} {incr c} {
				set uservar($c) $Cuservar($c)
			}
			if {$lang_flag} {
				source $mp3tool(dir)/languages/$mp3tool(language)
				update
				if [winfo exists .mp3] {
					destroy .mp3
					GetWindowSetup
				}
				if [winfo exists .help] {
					destroy .help
					MP3ToolHelp
				}
				if [winfo exists .select] {destroy .select}
				if [winfo exists .send] {destroy .send}
				if [winfo exists .recycle] {destroy .recycle}
				if [winfo exists .slots] {destroy .slots}
				if [winfo exists .olmp3] {destroy .olmp3}
				if [winfo exists .create] {destroy .create}
				if [winfo exists .lmp3] {destroy .lmp3}
				if [winfo exists .server] {
					destroy .server
					DrawServerWindow
				}
				if [winfo exists .setupque] {destroy .setupque}
				if [winfo exists .setspecial] {destroy .setspecial}
				if [winfo exists .queuser] {destroy .queuser}
				if [winfo exists .msg] {destroy .msg}
			}	
		}
		3	{
			# Save Only
			if {$platform == "platform unix"} {
				set outfile [open $mp3tool(dir)/MP3Tool.config w]
			} else {
				set outfile [open $mp3tool(dir)/MP3Tool.cfg w]
			}
			puts $outfile "set sends(CTCP) $Csends(CTCP)"
			puts $outfile "set sends(CHAN) $Csends(CHAN)"
			puts $outfile "set sends(FIND) $Csends(FIND)"
			puts $outfile "set sends(COLOR) $Csends(COLOR)"
			puts $outfile "set sends(LIST) $Csends(LIST)"
			puts $outfile "set sends(MAX_FIND) $Csends(MAX_FIND)"
			puts $outfile "set sends(STYLE) \"$Csends(STYLE)\""
			puts $outfile "set mp3tool(MAXINSEND) $Cmp3tool(MAXINSEND)"
			puts $outfile "set mp3tool(MAXINQUE) $Cmp3tool(MAXINQUE)"
			puts $outfile "set mp3tool(quemax) $Cmp3tool(quemax)"
			puts $outfile "set mp3tool(sendmax) $Cmp3tool(sendmax)"
			if [winfo exists .configure.info] {
				puts $outfile "set mp3tool(lineup) \"[.configure.info.c.e get]\""
				puts $outfile "set mp3tool(x11amp) \"[.configure.info.x.e get]\""
				puts $outfile "set filelist \"[.configure.info.l.e get]\""
				puts $outfile "set mp3tool(grand_file) \"[.configure.info.r.e get]\""
			} else {
				puts $outfile "set mp3tool(lineup) \"$Cmp3tool(lineup)\""
				puts $outfile "set mp3tool(x11amp) \"$Cmp3tool(x11amp)\""
				puts $outfile "set filelist \"$Cfilelist\""
				puts $outfile "set mp3tool(grand_file) \"$Cmp3tool(grand_file)\""
			}
			puts $outfile "set mp3tool(maxmp3s) $Cmp3tool(maxmp3s)"
			puts $outfile "set mp3tool(maxrecent) $Cmp3tool(maxrecent)"
			puts $outfile "set mp3tool(freq) $Cmp3tool(freq)"
			puts $outfile "set mp3tool(autoplay) $Cmp3tool(autoplay)"
			puts $outfile "set mp3tool(debugger) $Cmp3tool(debugger)"
			puts $outfile "set mp3tool(language) $Cmp3tool(language)"
			puts $outfile "set grand_date \"$Cgrand_date\""
			puts $outfile "set mp3dirs \{ $Cmp3dirs \}"
			puts $outfile "set serverdirs \{ $Cserverdirs \}"
			puts $outfile "set mp3tool(distribute) $Cmp3tool(distribute)"
			for {set c 0} {$c <= 20} {incr c} {
				puts $outfile "set uservar($c) \"$uservar($c)\""
			}
			close $outfile
		}
	}
	destroy .configure
}

proc ConfigureMiscSettings {} {
	global tcl_platform mp3tool Cmp3tool
	global Cfilelist MS_State

	switch $MS_State {
		0 {
			set platform [array get tcl_platform platform]
			frame .configure.info
			frame .configure.info.l -relief sunken -borderwidth 2
			frame .configure.info.r -relief sunken -borderwidth 2
			frame .configure.info.x -relief sunken -borderwidth 2
			frame .configure.info.c -relief sunken -borderwidth 2
			frame .configure.info.lan -relief sunken -borderwidth 2		
			button .configure.info.l.l -activebackground "light blue" -activeforeground "red" -bg "light blue" -text [Trans file_list] -width 20 -command CreateList
			button .configure.info.r.l -activebackground "light blue" -activeforeground "red" -bg "light blue" -text [Trans grand_file] -width 20 -command CResetGrandDate
			button .configure.info.x.l -activebackground "light blue" -activeforeground "red" -bg "light blue" -text [Trans mp3_player] -width 20 -command CRunMP3Player
			button .configure.info.c.l -activebackground "light blue" -activeforeground "red" -bg "light blue" -text [Trans channel_lineup] -width 20
			entry .configure.info.l.e
			entry .configure.info.r.e
			entry .configure.info.x.e
			entry .configure.info.c.e
			label .configure.info.lan.what -text [Trans language] -bg \
				"light blue" -relief raised -borderwidth 2
			listbox .configure.info.lan.list -height 5 -width 20 \
				-relief raised  -yscrollcommand ".configure.info.lan.scrly set" \
				-xscrollcommand ".configure.info.lan.scrlx set"
			scrollbar .configure.info.lan.scrlx -command ".configure.info.lan.list xview" -orient horizontal
			scrollbar .configure.info.lan.scrly -command ".configure.info.lan.list yview"
			pack .configure.info -fill both -expand y
			pack .configure.info.lan -side right
			pack .configure.info.r .configure.info.l .configure.info.x .configure.info.c -fill both -expand y
			pack .configure.info.r.l -side left -fill y -expand n
			pack .configure.info.r.e -side left -fill both -expand y
			pack .configure.info.l.l -side left -fill y -expand n
			pack .configure.info.l.e -side left -fill both -expand y
			pack .configure.info.x.l -side left -fill y -expand n
			pack .configure.info.x.e -side left -fill both -expand y
			pack .configure.info.c.l -side left -fill y -expand n
			pack .configure.info.c.e -side left -fill both -expand y
			pack .configure.info.lan.what .configure.info.lan.scrlx -side top -fill x -expand y
			pack .configure.info.lan.list .configure.info.lan.scrly -side left -fill both -expand y
			bind .configure.info.lan.list <ButtonRelease> {set Cmp3tool(language) [selection get]}
			# Fucking Windows!
			set od [pwd]
			if {$platform == "platform unix"} {
				cd $mp3tool(dir)/languages
			} else {
				set drive [string range $mp3tool(dir) 0 1]
				set folder [string range $mp3tool(dir) 2 end]
				cd $drive
				cd $folder
			}
			foreach language [glob -nocomplain *] {
				.configure.info.lan.list insert end $language
				if {$language == $Cmp3tool(language)} {
					.configure.info.lan.list selection set end
					.configure.info.lan.list see end
				}
			}
			if {$platform == "platform unix"} {
				cd $od
			} else {
				set drive [string range $od 0 1]
				set folder [string range $od 2 end]
				cd $drive
				cd $folder
			}
			.configure.info.r.e insert end $Cmp3tool(grand_file)
			.configure.info.l.e insert end $Cfilelist
			.configure.info.x.e insert end $Cmp3tool(x11amp)
			.configure.info.c.e insert end $Cmp3tool(lineup)
			set MS_State 1
		}
		1 {
			pack forget .configure.info
			set MS_State 2
		}
		2 {
			pack .configure.info -fill both -expand y
			set MS_State 1
		}
	}

}

proc ConfigureServerDirs {} {
	global Cserverdirs Cmp3dirs SD_State
	switch $SD_State {
		0 {
			frame .configure.f
			frame .configure.f.bl -relief sunken -borderwidth 2
			frame .configure.f.br -relief sunken -borderwidth 2
			listbox .configure.f.bl.list -height 8 -width 40 \
				-relief raised  -yscrollcommand ".configure.f.bl.scrly set" \
				-xscrollcommand ".configure.f.bl.scrlx set"
			scrollbar .configure.f.bl.scrlx -command ".configure.f.bl.list xview" -orient horizontal
			scrollbar .configure.f.bl.scrly -command ".configure.f.bl.list yview"
			label .configure.f.bl.l -bg "light blue" -relief raised \
				-borderwidth 2 -text [Trans mp3_directories]
			button  .configure.f.bl.b -bg "light blue" -activebackground "light blue" -activeforeground "red" -text [Trans add_new_directory] -command CAddMP3Directory
			listbox .configure.f.br.list -height 8 -width 40 \
			-relief raised  -yscrollcommand ".configure.f.br.scrly set" \
				-xscrollcommand ".configure.f.br.scrlx set"
			scrollbar .configure.f.br.scrlx -command ".configure.f.br.list xview" -orient horizontal
			scrollbar .configure.f.br.scrly -command ".configure.f.br.list yview"
			label .configure.f.br.l -bg "light blue" -relief raised \
				-borderwidth 2 -text [Trans server_directories]
			button  .configure.f.br.b -bg "light blue" -activebackground "light blue" -activeforeground "red" -text [Trans add_new_directory] -command CAddServDirectory
			pack .configure.f -fill both -expand y
			pack .configure.f.br .configure.f.bl -side left -fill both -expand y
			pack .configure.f.bl.l -side top -fill x -expand y
			pack .configure.f.bl.b -side bottom -fill x -expand y
			pack .configure.f.bl.scrlx -fill x -expand y
			pack .configure.f.bl.list -side left -fill both -expand y
			pack .configure.f.bl.scrly -side left -fill both -expand n
			pack .configure.f.br.l -side top -fill x -expand y
			pack .configure.f.br.b -side bottom -fill x -expand y
			pack .configure.f.br.scrlx -fill x -expand y
			pack .configure.f.br.list -side left -fill both -expand y
			pack .configure.f.br.scrly -side left -fill both -expand n
			bind .configure.f.br.list <ButtonRelease> {DirOptions serverdirs [selection get]}
			bind .configure.f.bl.list <ButtonRelease> {DirOptions mp3dirs [selection get]}
			foreach dir $Cserverdirs {
				.configure.f.br.list insert end $dir
			}
			foreach dir $Cmp3dirs {
				.configure.f.bl.list insert end $dir
			}
			set SD_State 1
		}
		1 {
			pack forget .configure.f
			set SD_State 2
		}
		2 {
			pack .configure.f -fill both -expand y
			set SD_State 1
		}		
	}
}

proc ConfigureSendStyle {} {
	global SS_State Csends tcl_platform mp3tool

	switch $SS_State {
		0 {
			set platform [array get tcl_platform platform]
			frame .configure.style
			frame .configure.style.list
			frame .configure.style.text
			label .configure.style.l -text [Trans channel_send_style] \
				-bg "blue" -relief raised -fg "white"
			listbox .configure.style.list.list -height 4 -width 20 \
				-relief raised  -yscrollcommand ".configure.style.list.scrly set" \
				-xscrollcommand ".configure.style.list.scrlx set"
			scrollbar .configure.style.list.scrlx -command ".configure.style.list.list xview" -orient horizontal
			scrollbar .configure.style.list.scrly -command ".configure.style.list.list yview"
			text .configure.style.text.text -height 5 -width 60 -state disabled
			pack .configure.style -fill both -expand y
			pack .configure.style.l -side top -fill both -expand y
			pack .configure.style.list .configure.style.text -side left -fill both -expand y
			pack .configure.style.list.scrlx -side top -fill both -expand y
			pack .configure.style.list.list  -side left -fill both -expand y
			pack .configure.style.list.scrly -side left -fill both -expand n
			pack .configure.style.text.text -fill both -expand y
			bind .configure.style.list.list <ButtonRelease> {DrawStyle [selection get]}
			# Fucking Windows!
			set od [pwd]
			if {$platform == "platform unix"} {
				cd $mp3tool(dir)/styles
			} else {
				set drive [string range $mp3tool(dir) 0 1]
				set folder [string range $mp3tool(dir) 2 end]
				cd $drive
				cd $folder
			}
			foreach style [glob -nocomplain *] {
				.configure.style.list.list insert end $style
				if {$style == $Csends(STYLE)} {
					.configure.style.list.list selection set end
					.configure.style.list.list see end
				}
			}
			if {$platform == "platform unix"} {
				cd $od
			} else {
				set drive [string range $od 0 1]
				set folder [string range $od 2 end]
				cd $drive
				cd $folder
			}
			DrawStyle $Csends(STYLE)
			set SS_State 1
		}
		1 {
			pack forget .configure.style
			set SS_State 2
		}
		2 {
			pack .configure.style -fill both -expand y
			set SS_State 1
		}		
	}
}
